/* global vitaraJQ */

import {agGrid} from 'ag-grid-enterprise/dist/ag-grid-enterprise.min'
import {utils} from '../../core/utils'
import {VitaraGridChartColumnMenu} from './VitaraGridChartColumnMenu'
import { VitaraGridChartLegacyColumnMenu } from './VitaraGridChartLegacyColumnMenu'
import {VitaraGridChartHamburgerMenu} from './VitaraGridChartHamburgerMenu'
import {VitaraGridChartEventListeners} from './VitaraGridChartEventListeners'
import {VitaraGridChartFilterThreshold} from './VitaraGridChartFilterThreshold'
import {VitaraStateManager} from './StateManager/VitaraGridChartStateManager'
import {VitaraGridChartSortingModel} from './gridModels/VitaraGridChartSortingModel'
import {VitaraGridChartColumnStateMaster} from './gridModels/ColumnStateModel/VitaraGridChartColumnStateMaster'
import {VitaraGridChartColumnGroupingModel} from './gridModels/VitaraGridChartColumnGroupingModel'
import {VitaraGridChartColumnFormattingModel} from './gridModels/ColumnFormattingModel/VitaraGridChartColumnFormattingModel'
import {VitaraGridChartChildrenCountModel} from './gridModels/VitaraGridChartChildrenCountModel'
import {VitaraGridChartGrandTotalsModel} from './gridModels/VitaraGridChartGrandTotalsModel'
import {VitaraGridChartSubTotalsModel} from './gridModels/VitaraGridChartSubTotalsModel'
import {VitaraGridChartColumnGroupingView} from './gridViews/VitaraGridChartColumnGroupingView'
import {VitaraGridChartThemeFormattingModel} from './gridModels/ThemeFormattingModel/VitaraGridChartThemeFormattingModel'
import {VitaraGridChartAggregationWrapperModel} from './gridModels/AggregationWrapperModel/VitaraGridChartAggregationWrapperModel'
import {VitaraGridPropertyEditorMapper} from './gridMappers/VitaraGridPropertyEditorMapper'
import {VitaraGridChartHeaderFormattingView} from './gridViews/DefaultRenderers/VitaraGridChartHeaderFormattingView'
import {VitaraGridChartDefaultRenderer} from './gridViews/DefaultRenderers/VitaraGridChartDefaultRenderer'
import {VitaraGridChartThresholdModel} from './gridModels/ThresholdModels/VitaraGridChartThresholdModel'
import {VitaraGridChartEventDispatcher} from './gridEventHelper/VitaraGridChartEventDispatcher'
import {VitaraGridChartChooseColumnModel} from './gridModels/AggregationWrapperModel/VitaraGridChartChooseColumnModel'
import {VitaraGridChartThresholdView} from './gridViews/VitaraGridChartThresholdView'
import {VitaraGridChartRatioModel} from './gridModels/VitaraGridChartRatioModel'
import {VitaraGridChartRatioView} from './gridViews/VitaraGridChartRatioView'
import {VitaraGridChartRowGroupOpenedModel} from './gridModels/ColumnStateModel/VitaraGridChartRowGroupOpenedModel'
import {VitaraGridChartColumnResizeModel} from './gridModels/ColumnStateModel/GridWidthModel/VitaraGridChartColumnResizeModel'
import {VitaraGridChartGridThemeView} from './gridViews/gridPropertyEditorViews/VitaraGridChartGridThemeView'
import {VitaraGridChartFormatColumnView} from './gridViews/gridPropertyEditorViews/VitaraGridChartFormatColumnView'
import {VitaraGridChartGridThemeModel} from './gridModels/ThemeFormattingModel/VitaraGridChartGridThemeModel'
import {VitaraMicroChartTypeModel} from './microModels/VitaraMicroChartTypeModel';
import {VitaraMicroChartPlotTypeSelectorModel} from './microModels/VitaraMicroChartPlotTypeSelectorModel';
import {chartDataMapperBase} from '../../core/chartDataMapperBase';
import {VitaraGridChartSimpleHeaderComponent} from "./gridViews/VitaraGridChartSimpleHeaderComponent";
import {VitaraGridChartPivotDropZoneModel} from "./gridModels/DropZoneModels/VitaraGridChartPivotDropZoneModel";
import {VitaraGridChartGroupingDropZoneModel} from "./gridModels/DropZoneModels/VitaraGridChartGroupingDropZoneModel";
import {VitaraGridChartRowSelectedModel} from "./gridModels/VitaraGridChartRowSelectedModel";
import {VitaraChartTypeModel} from "./VitaraChartTypeModel";
import {VitaraGridChartPropertyEditorRTLLayoutModel} from "./gridModels/VitaraGridChartPropertyEditorRTLLayoutModel";
import {VitaraGridChartExportToCSV} from './gridViews/VitaraGridChartExportToCSV';
import {VitaraGridChartFilterView} from './gridViews/VitaraGridChartFilterView';
import {VitaraGridChartColumnOrderModel} from './gridModels/ColumnStateModel/VitaraGridChartColumnOrderModel';
import {VitaraGridChartMetricToRowsModel} from './gridModels/VitaraGridChartMetricToRowsModel';
import {VitaraGridChartCustomTooltipModel} from './gridModels/VitaraGridChartCustomTooltipModel';
import { CustomTooltip } from "./gridViews/VitaraGridCustomTooltip";
import {VitaraGridChartTrendingModel} from './gridModels/VitaraGridChartTrendingModel';
import {VitaraGridChartTrendlineRenderer} from './gridViews/DefaultRenderers/VitaraGridChartTrendlineRenderer';
import {VitaraGridChartAnimationModel} from './gridModels/VitaraGridChartAnimationModel';
import { VitaraGridChartAllowURLsModel } from './gridModels/VitaraGridChartAllowURLsModel';
import { VitaraGridChartCheckboxModel } from './gridModels/VitaraGridChartCheckboxModel'
import { VitaraGridChartCustomMarkerModel } from './gridModels/VitaraGridChartCustomMarkerModel';
import {VitaraGridChartColumnGroupOpenedModel} from './gridModels/VitaraGridChartColumnGroupOpenedModel';
//Importing all the views here
import {VitaraGridChartSortingView} from './gridViews/VitaraGridChartSortingView';
import {VitaraGridChartTrendlineOptionsView} from './gridViews/VitaraGridChartTrendlineOptionsView';
import {VitaraGridChartGrandTotalsView} from './gridViews/VitaraGridChartGrandTotalsView';
import {VitaraGridChartSubTotalsView} from './gridViews/VitaraGridChartSubTotalsView';
import {VitaraGridChartCustomMarkerView} from './gridViews/VitaraGridChartCustomMarkerView';
import {VitaraGridChartAggregationHelper} from './dataHelpers/VitaraGridChartAggregationHelper'; 
import { VitaraMicroChartShowDetailRowsModel } from './microModels/VitaraMicroChartShowDetailRowsModel';
import {VitaraGridChartScalingModel} from './gridModels/VitaraGridChartScalingModel';
import {VitaraGridChartScalingView} from "./gridViews/VitaraGridChartScalingView";
import {VitaraGridChartDragDropManager} from "./gridViews/VitaraGridDragDropManager";
import {VitaraGridCustomFormattingEditor} from "./../VitaraGridCustomFormattingEditor";
import { CustomFormattingEditorModel } from './gridModels/CustomFormattingEditorModel';
import {ColumnSelectionModel} from "./gridModels/ColumnOperationsModel/ColumnSelectionModel";
import {CustomHeaderGroup} from "./gridViews/CustomHeaderGroup";
import { VitaraGridChartMetricGroupingModel } from './gridModels/VitaraGridChartMetricGroupingModel';
import { VitaraGridChartMetricGroupingView } from './gridViews/VitaraGridChartMetricGroupingView';
var VitaraAgGrid = function(customGridOptions) {
                /* global gridOptions, agGrid, self, groupedColumns */
                // Defining default options
                console.time("gridHelperTime");
                var self = this,
                    contextMenuState = 0,
                    contextMenu,
                    bgImageOptions = {},
                    style = document.createElement('style');
                
                self.customFormatEditor = null;
                self.utils = utils;
                self.customGridOptions = customGridOptions;
                self.columnAutoSize = {};
                self.groupLevelAgg = {};
                self.colDataTemplate = {};
                self.dragResized = "";
                self.cellElement = null;
                self.spanStyle = ''; //Temp fix to be removed
                self.renderValue = '';
                var defaults = {
                    gridArea: null,  
                    suppressPropertyNamesCheck: true,               
                    width: '100%',
                    height: "auto",
                    propMenuWidth: '400px',
                    propMenuHeight: '600px',
                    rowPerPage: 25,
                    groupHeaders: true,
                    toolPanel: "columns",
                    forPrint: false,
                    groupUseEntireRow: false,
                    getRowHeight: getRowHeightFunc,
                    suppressContextMenu: true,
                    suppressMenuFilterPanel: false,
                    suppressFieldDotNotation: true,
                    components: {
                        customTooltip: CustomTooltip
                    },
                    headerComponentParams: {
                        "gridContext": this,
                        "filterModel": self.filterModel
                    },
                    isExternalFilterPresent: isExternalFilterPresent,
                    doesExternalFilterPass: doesExternalFilterPass,
                    customThemes: [],
                    customIcons: [],
                    showModules: ['autosize', 'resetcolumns', 'advanceSorting','thresholds', 'gridtheme', 'showhide', 'export', 'footer'],
                    colDef: {
                        menuTabs: ['generalMenuTab','filterMenuTab','columnsMenuTab']
                    },
                    getRowId: function (params) {
                        return params.data.id;
                    }
                };

                var extendDefaults = function(source, properties) {
                    var property;
                    for (property in properties) {
                        if (properties.hasOwnProperty(property)) {
                            source[property] = properties[property];
                        }
                    }
                    return source;
                };

                var gridOptions = this.gridOptions = extendDefaults(defaults, arguments[0]);
                gridOptions.enableRtl = self.getPropertyEditorRTLLayoutModel().getLayoutModel();
                this.gridOptions.enableRtl = gridOptions.enableRtl;
                gridOptions.pivotPanelShow = self.getPivotDropZoneModel().isPivotDropZoneVisible(gridOptions);
                gridOptions.suppressColumnFilter = true;
                gridOptions.rowGroupPanelShow = self.getGroupingDropZoneModel().isGroupingDropZoneVisible(gridOptions);
                gridOptions.groupMultiAutoColumn = false;
                gridOptions.animateRows = self.getAnimationModel().isAnimated();
                gridOptions.suppressColumnMoveAnimation = !self.getAnimationModel().isAnimated();
                gridOptions.suppressDragLeaveHidesColumns = true;
                gridOptions.rowSelection = "multiple";
                gridOptions.rowDeselection = true;
                gridOptions.multiSortKey = "ctrl";
                gridOptions.groupSelectsChildren = false;
                gridOptions.pivotColumnGroupTotals  = self.getSubTotalsModel().isMetricTotals() ? "after": undefined;
                gridOptions.pivotRowTotals = self.getSubTotalsModel().isMetricTotals() ? "after": undefined;
                let headerHeight= self.getThemeFormattingModel().themeHeaderFormattingModel.getHeight();
                gridOptions.headerHeight = headerHeight + 3;
                gridOptions.groupHeaderHeight = headerHeight + 3;
                gridOptions.pivotHeaderHeight = headerHeight + 3;
                gridOptions.pivotGroupHeaderHeight = headerHeight + 3;
                gridOptions.suppressExpandablePivotGroups = self.getSubTotalsModel().isPivotMetricTotals() ? false: true;
                gridOptions.tooltipShowDelay = 250;
                gridOptions.tooltipHideDelay = 2500;
                gridOptions.localeTextFunc = function(defaultStr, strToConvert) {
                    let translatedText = gridOptions.context.utils.convertStringLanguage(strToConvert);
                    if(typeof translatedText === "undefined") {
                        translatedText = defaultStr;
                    }
                    return translatedText;
                };
                gridOptions.processPivotResultColDef = colDef => {
                    colDef.filter = false;
                };
                gridOptions.maintainColumnOrder = true;

                gridOptions.processPivotResultColGroupDef = colGroupDef => {
                    if(colGroupDef.pivotKeys.length === 0) {
                        let allMetrics = self.getColumnStateMaster().getAllMetrics();
                        let totalIndex = allMetrics.indexOf("Total");
                        if(totalIndex > -1) {
                            allMetrics.splice(totalIndex);
                        }
                        // if(allMetrics.length === 1 && colGroupDef.children[0].headerName === allMetrics[0]) {
                        //     colGroupDef.children[0].headerName = "Total";
                        // } else {
                        //     colGroupDef.children[0].hide = true;
                        // }
                    }
                    if (!self.getSubTotalsModel().isMetricTotals()) {
                        if (self.getSubTotalsModel().isPivotMetricTotals()) {
                            if (self.getMetricToRowsModel().isMetricToRows()) return;
                            if (colGroupDef.children.length === self.gridOptions.chartDataMapper.numMetrics){
                                colGroupDef.children[0].columnGroupShow = null;
                            } 
                        } else {
                            colGroupDef.children.forEach((childDef, idx) => {
                                childDef.columnGroupShow = idx === 0 ? null : 'open';
                            });
                        }
                    }
                };
                //Adding custom aggregation functions
                let aggregation_helper = self.getAggregationHelper();
                let ratioAggregation = aggregation_helper.ratioAggregationFunction.bind(aggregation_helper);
                let sumAggregation = aggregation_helper.sumAggregation.bind(aggregation_helper);
                let minAggregation = aggregation_helper.minAggregation.bind(aggregation_helper);
                let maxAggregation = aggregation_helper.maxAggregation.bind(aggregation_helper);
                let firstAggregation = aggregation_helper.firstAggregation.bind(aggregation_helper);
                let lastAggregation = aggregation_helper.lastAggregation.bind(aggregation_helper);
                let meanAggregation = aggregation_helper.meanAggregation.bind(aggregation_helper);
                let countAggregation = aggregation_helper.countAggregation.bind(aggregation_helper);
                gridOptions.aggFuncs = {
                    ratio: ratioAggregation,
                    sum: sumAggregation,
                    min: minAggregation,
                    first: firstAggregation,
                    last: lastAggregation,
                    max: maxAggregation,
                    avg: meanAggregation,
                    count: countAggregation,
                    choosecolumn: sumAggregation,
                    clearAggregation: sumAggregation
                }
                self.showColumn = [];
              
                gridOptions.getRowClass = params => {
                    if(params.node.isRowPinned()) {
                        return ' vitara-grand-totals vitara-grand-totals-row ';
                    }
                    var finalClass = "vitara-row ";
                    if(params.node.group) {
                        finalClass += "vitara-grid-row-group ";
                        if(params.node.expanded) {
                            finalClass += "vitara-grid-row-group-expanded ";
                        } else {
                            finalClass += "vitara-grid-row-group-contracted ";
                        }
                    }
                    if(params.node.selected) {
                        finalClass += "vitara-grid-row-selected ";
                    }
                    if (params.node.rowIndex % 2 === 0) {
                        finalClass += "vitara-grid-row-even ";
                    } else {
                        finalClass += "vitara-grid-row-odd ";
                    }
                    return finalClass;
                };

                function redrawRowsRaw(){
                    if(gridOptions && gridOptions.api){
                        setTimeout(function(){
                            gridOptions.api.redrawRows();
                        },0);
                    }
                    self.getEventDispatcher().createAndDispatchEvent("redrawRows", "gridContext");
                }
                self.redrawRows = vitaraLD.debounce(redrawRowsRaw, 500, {'leading': false, 'trailing': true,'maxWait':1000});
                
                //Assigning Variables

                //TO be cleared after filter refactor
                self.defaultColumnDef;
                self.customGridMenuItems = [];
                self.columnvalues = [];
                self.columnaggregates = [];
                self.columnuniquevalues = [];
                self.bottompercentages = [];
                self.toppercentages = [];
                self.betweenpercentages = [];
                self.newBetweenpercentages = [];
                self.bottombetweenpercentages = [];
                self.topbetweenpercentages = [];
                self.iconsettoppercentages = [];
                self.iconsetbottompercentages = [];
                self.filterThresholdArrays = {};
                self.filterThresholdArrays['filter'] = {};
                self.filterThresholdArrays['threshold'] = {};
                self.filter = [];
                self.recentColors = [];
                self.saveColorHistoryKey = 'vitara.recentColors';
                //self.hideChildrenCount = false;


                function getRowHeightFunc(params) {
                    if(params !== undefined && params.node.group ) {
                        return self.getThemeFormattingModel().themeBodyFormattingModel.getGroupedHeight();
                    }
                    return self.getThemeFormattingModel().themeBodyFormattingModel.getHeight();
                }

                self.destroy = function() {
                    if(!isExporting()) { //temporary workaround
                        if(self.gridOptions !== null) {
                            // self.gridOptions.interface.destroy();
                        }
                        Object.keys(self).forEach(function(ownKey) {
                            if (typeof self[ownKey] === 'object' && ownKey !== "renderedGrid") {
                                self[ownKey] = null;
                            }
                        })
                        self.groupedColumns = null;
                        if (self.renderedGrid) {
                            self.renderedGrid.destroy();
                            self.renderedGrid = null;
                        }
                    }
                };

                function isExternalFilterPresent() {
                    return true;
                }

                function doesExternalFilterPass(node) {
                    if(self.getFilterModel().getAllThresholds().length === 0){
                            return true;
                    }
                    var filterPassArr = [];
                    if(node.data !== undefined) {
                        Object.keys(node.data).forEach(function(dataKey){
                            var filterPass = true;
                            if(typeof node.data[dataKey] === 'object') {
                                var filterPassVals = self.getFilterModel().getThresholdStyles(dataKey, node.data[dataKey]['rawValue']);
                                filterPass = ((filterPassVals === null) === (self.getFilterModel().filterThresholdByMetric(dataKey).length === 0));
                                filterPassArr.push(filterPass);
                            }
                           
                        });
                    }
                    return !(filterPassArr.indexOf(false) > -1); 
                   
                }

                self.styleMapper = {
                    "font-size":"fontSize",
                    "text-decoration":"textDecoration",
                    "font-style":"fontStyle",
                    "font-family": "fontFamily",
                    "font-weight":"fontWeight",
                    "text-align": "textAlign",
                    "color":"color",
                    "background-color": "bgColor"
                };
                var readGridDataAndDefiniton = function() { //read grid data and definition
                   // var interfaceSource = gridOptions.interface;
                   if (!gridOptions.chartDataMapper){
                        gridOptions.chartDataMapper = new chartDataMapperBase(gridOptions.interface.getDataAsArray(), gridOptions.interface.getTitles(), gridOptions.interface.numAttributes, {
                            data: gridOptions.interface.data
                        });
                    }
                    var interfaceSource = gridOptions.chartDataMapper;
                    var coldata = [];
                    var columns = [];
                    var cellTemplate = '';
                    var ColumnDefinition_local = ColumnDefinition;
                    var interfaceSource_numColumns = interfaceSource.numColumns;
                    var numRows = interfaceSource.dataRows.length;
                    var parseFloat_l = parseFloat;
                    var isNaN_l = isNaN;
                    var name = [];
                    var namelower = [];
                    var isMetric = {};
                    var numAttributes = 0;
                    var cInterfaceTitles = self.getTitles();
                    var interfaceTitles = cInterfaceTitles.slice();
                    if(typeof self.getColumnOrderModel().orderModel !== "undefined") {
                        interfaceTitles = self.getColumnOrderModel().getOrderedTitles(cInterfaceTitles.slice());
                        interfaceTitles = interfaceTitles.filter(function(e){ 
                            return (e !== "ag-Grid-AutoColumn") && (e !== "Total")
                        });
                    }
                    var createColDef = function() {
                        /**
                         * [createColDef description]
                         * Earlier merged in the iterator, now this function has been separated out. This function is called once
                         * and it creates the column definition of the dataset.
                         */
                        let isPivoted = false;
                        numAttributes = interfaceSource.numAttributes;
                        interfaceTitles.forEach(function(column, iterator){
                            var columnIndex = cInterfaceTitles.indexOf(column);
                            isMetric[columnIndex] = !(columnIndex < numAttributes);
                            if (isMetric[columnIndex]) {
                                self.colDataTemplate[column] = interfaceSource.hcFormattedMetricVal(interfaceSource.dataRows[0][columnIndex]);
                            }
                            name.push(self.formatNames(column));
                            var namelowervar = column.toLowerCase();
                            namelower.push(namelowervar);
                            isPivoted = isPivoted || ( self.getColumnStateMaster().getSubStateValue("pivotIndex", column, null) !== null);
                            columns[iterator] = ColumnDefinition_local(column, column, isMetric[columnIndex], self);
                            if (typeof self.columnvalues[namelowervar] === 'undefined') {
                                        self.columnvalues[namelowervar] = [];
                                        self.columnaggregates[namelowervar] = [];
                                        self.columnaggregates[namelowervar]['total'] = 0;
                                    }
                                    if (typeof self.columnuniquevalues[namelowervar] === 'undefined') {
                                        self.columnuniquevalues[namelowervar] = [];
                                    }
                        });
                        //Add a totals column
                        if(self.getSubTotalsModel().isMetricTotals() && !isPivoted) {
                            columns.push(ColumnDefinition_local("Total", "Total", true, self))
                        }
                    }

                    
                    var direct_iterator = function(rowIndex) {
                        /**
                         * [direct_iterator description]
                         * This function is the optimal replacement to the older "iterator" Function
                         * This function is called for every row in the dataset.
                         */
                        coldata[rowIndex] = {};
                        coldata[rowIndex].id = rowIndex;
                        interfaceTitles.forEach(function(column, iterator){
                            var columnIndex = cInterfaceTitles.indexOf(column);
                            var rawValue;
                            if (isMetric[columnIndex]) { //metric
                                rawValue = interfaceSource.hcMetricVal(interfaceSource.dataRows[rowIndex][columnIndex]);

                                if (rawValue == '' || isNaN_l(rawValue))
                                    rawValue = 0;
                                coldata[rowIndex]["selector"] = interfaceSource.dataRows[rowIndex][columnIndex]["selector"];
                                if(rawValue !== null) {
                                    rawValue = parseFloat_l(rawValue); 
                                  }
                                coldata[rowIndex][name[iterator]] = {};
                                coldata[rowIndex][name[iterator]].value = interfaceSource.hcFormattedMetricVal(interfaceSource.dataRows[rowIndex][columnIndex]);
                                coldata[rowIndex][name[iterator]].rawValue = rawValue;
                                self.columnaggregates[namelower[iterator]]['total'] += rawValue;
                                self.columnvalues[namelower[iterator]][rowIndex] = rawValue;

                                if (!self.uniqueCollector[namelower[iterator]]) {
                                    self.uniqueCollector[namelower[iterator]] = {};
                                }

                                self.uniqueCollector[namelower[iterator]][rawValue] = EMPTY_STRING;
                            } else { //attribute
                                var value = interfaceSource.dataRows[rowIndex][columnIndex].t;
                                coldata[rowIndex][name[iterator]] = value;
                                self.columnvalues[namelower[iterator]][rowIndex] = value;
                            }
                            coldata[rowIndex]["dataRow"] = interfaceSource.dataRows[rowIndex];


                        });
                    };
                    createColDef();
                    self.uniqueCollector = [];
                    var EMPTY_STRING = "";
                    
                    
                    for (var rowIndex = 0; rowIndex < numRows; ++rowIndex) {
                        direct_iterator(rowIndex);
                    }
                    for (var columnIndex = numAttributes; columnIndex < interfaceSource_numColumns; ++columnIndex) {
                        if (self.uniqueCollector[cInterfaceTitles[columnIndex]]){
                            self.columnuniquevalues[namelower[columnIndex]] = Object.keys(self.uniqueCollector[cInterfaceTitles[columnIndex].toLowerCase()]);
                            //Sortnumber call remove
                            self.columnuniquevalues[namelower[columnIndex]] = self.columnuniquevalues[namelower[columnIndex]].map(function(stringVal) {
                                return parseFloat(stringVal) }).sort(sortNumber);
                            self.columnvalues[namelower[columnIndex]] = self.columnvalues[namelower[columnIndex]].sort(sortNumber);
                        }
                    }

                    self.defaultColumnDef = columns;
                    var columnDefs = [];

                    //Purpose??
                    //if (typeof state !== 'undefined' && typeof state['groupedColumns'] !== 'undefined' && state['groupedColumns'] !== '') {
                        var GCcolumnstate = self.getColumnGrouping().getColumnGroupingModel();
                        for (var temp1 = 0; temp1 < GCcolumnstate.length; temp1++) {
                            var GCcurcolumnstate = GCcolumnstate[temp1];
                            if (typeof GCcurcolumnstate.columns !== 'undefined') {
                                var columnstate = GCcurcolumnstate.columns;
                                for (var temp = 0; temp < columnstate.length; temp++) {
                                    var curcolumnstate = columnstate[temp];
                                    var check = self.defaultColumnDef.filter(function(ob) {
                                        return ob.colId == curcolumnstate;
                                    });
                                    if (check.length == 0) {
                                        columnstate.splice(temp, 1);
                                    }
                                }
                            }
                            GCcolumnstate[temp1].columns = columnstate;
                        }
                        self.groupedColumns = GCcolumnstate;
                    //}
                    var groupedColumnslength = self.getColumnGrouping().getColumnGroupingModel().length;
                    // if (groupedColumnslength > 0) {
                    //     columnDefs = getGroupedColumnDef(columns);
                    // } else {
                        columnDefs = columns;
                    // }
                    return {
                        columnDefs: columnDefs,
                        rowData: coldata
                    };
                };

                var addGridMenu = function() { // remove it to columnMenu file
                    var html = '';
                    html += '<div id="context-menu" class="vitara-grid-menu-container">';
                    html += '<div class="vitara-grid-menu-mid">';
                    html += '<div class="vitara-grid-menu-inner">';
                    html += '<ul role="menu" class="vitara-grid-menu-items">';
                    html += '</ul>';
                    html += '</div>';
                    html += '</div>';
                    html += '</div>';
                    vitaraJQ(gridOptions.gridArea).append(html);
                    contextMenu = gridOptions.gridArea.querySelector('#context-menu');
                };

                var getCreateStyle = function(id){
                    var style = document.createElement('style');
                    style.id = id;
                    document.head.appendChild(style);
                    return style;
                }

                var getCustomStyleSheet = function(){
                    var STYLE_SHEET_ID = "VitaraGridChartStyles";
                    var customStyleSheet = document.getElementById(STYLE_SHEET_ID);
                    if (!customStyleSheet) {
                        customStyleSheet = getCreateStyle(STYLE_SHEET_ID);
                    }
                    return customStyleSheet;
                }
                
                var insertNewCssRule = function(strRule){
                    var styleSheet = getCustomStyleSheet().sheet;
                    styleSheet.insertRule(strRule, styleSheet.cssRules.length || 0);
                }

                var updateCssRule = function(strRule, className="") {
                    var styleSheet = getCustomStyleSheet().sheet;
                    if(typeof styleSheet.cssRules === "undefined") {
                        insertNewCssRule(strRule);
                        return;
                    }
                    var found = false;
                    for(var i=0;i<styleSheet.cssRules.length;i++){
                        if(styleSheet.cssRules[i]["selectorText"] === className) {
                            styleSheet.deleteRule(i);
                            styleSheet.insertRule(strRule, i);
                            found  = true;
                            break;
                        }
                    }
                    if(!found) {
                        insertNewCssRule(strRule);
                    }
                }
                this.updateCssRule = updateCssRule;
               
                /**
                    as we discover a grouped node, we cache the agg values corresponding to each group level
                    this grouping information is used later to compute threshold elements and to apply formatting
                 **/
               
                var initiateGrid = function(columnsData) {
                    self.gridState = "initializing";
                    if (gridOptions) {
                        if (gridOptions.gridArea) {
                            gridOptions.proversion = {
                                menus: []
                            };
                            //Setting the width and height of the grid container
                            gridOptions.hideClearGrouping = false;
                            gridOptions.gridArea.style.width = gridOptions.width;
                            gridOptions.gridArea.style.height = gridOptions.height;
                            gridOptions.gridArea.style.position = 'relative';
                            gridOptions.gridArea.className = gridOptions.class;
                            var cellClicked = 0;
                            var prevClickEle = '';
                        }
                        //Assign Column Definition to grid Options
                        gridOptions.columnDefs = columnsData.columnDefs;
                        gridOptions.rowData = null;
                        //Fitting columns to grid

                        gridOptions.onGridReady = function() {
                            if (gridOptions) {
                                if(isExporting()){
                                    let api = gridOptions.columnApi;
                                    api && api.getColumnGroupState().forEach(group => {
                                       group && api.setColumnGroupOpened(group.groupId, true);
                                    });
                                }else {
                                    this.context.getResultPropMenuChecks() &&
                                    self.getCustomFormatEditor().initEditor({
                                        selector: `${this.context.getUniqueIdInContainer('editorTextarea')}`
                                    });
                                }
                                self.getRowGroupOpenedModel().hideBottomLeafRow();
                                let columnOrder = self.getColumnOrderModel();
                                columnOrder.registerEventListeners();
                                columnOrder.reorderAutocol(true);
                                columnOrder.reorderTotalColumn();
                                self.getSortingModel().addEventListeners();
                                self.getSortingModel()._setColumnSortingState();
                                self.getEventDispatcher().createAndDispatchEvent("gridReady",null);
                                self.gridOptions.api.addEventListener("columnRowGroupChanged", function(event){
                                    if(self.getGroupingDropZoneModel().isGroupingDropZoneVolatile() && self.getPivotDropZoneModel().isPivotDropZoneVolatile()){
                                        self.getGroupingDropZoneModel().setGroupingDropZoneVisible();
                                        self.getPivotDropZoneModel().setPivotDropZoneVisible();
                                    } else { 
                                        self.getPivotDropZoneModel().showPivotDropZone();
                                    }
                                });
                                self.gridOptions.api.addEventListener("columnPivotChanged", function(event){
                                    if(self.getGroupingDropZoneModel().isGroupingDropZoneVolatile() && self.getPivotDropZoneModel().isPivotDropZoneVolatile()){
                                        self.getGroupingDropZoneModel().setGroupingDropZoneVisible();
                                        self.getPivotDropZoneModel().setPivotDropZoneVisible();
                                    } else {
                                        self.getPivotDropZoneModel().showPivotDropZone();
                                    }
                                });
                                self.getRowSelectedModel().setRowsSelected();
                                // self.getPivotDropZoneModel().appendPivotDropZoneListener();
                                self.getColumnResizedModel().checkAndApplyResizing(true);
                                self.getHeaderFormattingView();
                                //check for grouped node and expand it if ready 
                              
                                //initialize column grouping listeners
                                self.getColumnGrouping().addEventListeners();
                                self.getColumnStateMaster().registerEventListeners();
                                
                                // self.getColumnStateMaster().columnShowHideModel.applyColumnVisibility()
                                self.getColumnGroupOpenedModel().applyColumnGroupState();
                                // self.getColumnResizedModel().checkAndApplyResizing();
                                if(self.getChartTypeModel().isMicroChart()) {
                                    self.hideMicroAttribute();
                                }
                                self.getHeaderFormattingView().applyHeaderColors();
                            }
                            self.gridState = "ready";
                            console.timeEnd("gridHelperTime");
                            if(gridOptions.gridReadyCallback){
                                try{
                                    gridOptions.gridReadyCallback.call();
                                }catch(error){
                                    console.error(error);
                                }
                            }
                        };

                        //Initializing the grid
                        agGrid.LicenseManager.setLicenseKey("Using_this_AG_Grid_Enterprise_key_( AG-048674 )_in_excess_of_the_licence_granted_is_not_permitted___Please_report_misuse_to_( legal@ag-grid.com )___For_help_with_changing_this_key_please_contact_( info@ag-grid.com )___( Vitara LLC )_is_granted_a_( Single Application )_Developer_License_for_the_application_( VitaraCharts )_only_for_( 1 )_Front-End_JavaScript_developer___All_Front-End_JavaScript_developers_working_on_( VitaraCharts )_need_to_be_licensed___( VitaraCharts )_has_been_granted_a_Deployment_License_Add-on_for_( 1 )_Production_Environment___This_key_works_with_AG_Grid_Enterprise_versions_released_before_( 8 December 2024 )____[v2]_MTczMzYxNjAwMDAwMA==3d5514a89bc8943ace85178191f5b10b");
                        self.renderedGrid = new agGrid.Grid(gridOptions.gridArea, gridOptions);
                        self.getGridOptions = function (){
                            return self.gridOptions;
                        };

                        //Getting models

                        if(self.customGridOptions.chartType === "micro") {
                            self.getChartTypeModel().setMicroChart();
                        } else {
                            self.getChartTypeModel().setGridChart();
                        }
                        self.getPivotDropZoneModel().showPivotDropZone();
                        self.getGridThemeView();
                        self.newTitles = self.getTitles();
                        self.gridOptions.chartDataMapper.titles = self.newTitles;
                        self.getThemeModel();
                        let csm = self.getColumnStateMaster();
                        csm.updateState();
                        csm.declareModels();
                        csm.manageTotalsColumn();
                        csm.columnShowHideModel.applyColumnVisibility()
                        self.columnGroupingModel = self.getColumnGrouping(); 
                        self.getShowDetailRowsModel();
                        self.getColumnGroupingView();
                        self.getColumnFormattingModel();
                        self.getThemeFormattingModel();
                        self.getAggregationWrapperModel();
                        self.getColumnResizedModel();
                        self.getRowSelectedModel();
                        self.getPropertyEditorRTLLayoutModel();
                        self.getColumnOrderModel();
                        self.getScalingModel();
                        if (!self.getMetricToRowsModel().isMetricToRows() &&self.getMetricGroupingModel().isMetricGroupsPresent()){
                            self.getMetricGroupingModel().convertToColumnGrouping();
                        } else if(!self.getColumnGrouping().isColumnGroupingCleared()) {
                            self.getColumnGrouping().ApplyGroupColDef();
                        }
                        
                        // for time being restoring filter
                        self.filter = self.getStateManager().restoreSpecificState('filter');
                        if(self.filter === undefined) {
                            self.filter = [];
                        }
                        (function() {
                            if (gridOptions) {

                                addGridMenu();

                                // populate pinned bottom row data a.k.a aggrgated row
                                self.getGrandTotalsModel();
                                self.getSubTotalsModel();
                                // set All Event Listeners
                                self.getChartEventListener(contextMenuState, contextMenu).setGridChartEventListener(self).setEventListeners(cellClicked, prevClickEle, self.themeFormat);
                                utils.setBackgroundImage(vitaraJQ(gridOptions.gridArea).parent(), bgImageOptions);
                            }
                        }());
                    }

                };
                self.formatNames = function(value) {
                    return value.replace(/([])+/g, '_').replace(/^(_)+|(_)+$/g, '_');
                };

                self.removeSpecials = function(value) {
                    return value.replace(/([~!@#$%^&*()_+=`{}\[\]\|\\:;'<>,.\/? ])+/g, '-').replace(/^(-)+|(-)+$/g, '-');
                };

                self.isColorTransparent = function(colorString) {
                    const cleanedColorString = colorString ? colorString.replace(/\s/g, '') : '';
                    const rgba = cleanedColorString.match(/rgba?\((\d+),(\d+),(\d+),([0-9.]+)\)/);
                    if (rgba) {
                        const alpha = Number(rgba[4]);
                        return alpha === 0;
                    } else {
                        return false;
                    }
                };

                self.getTitles = function() {
                    var titles = self.gridOptions.chartDataMapper.titles.slice();
                    var formattedTitles = [];
                    titles.forEach(function(title){
                        formattedTitles.push(self.formatNames(title));
                    });
                    return formattedTitles;
                };

                self.isMetric = function(metricName) {
                    if(typeof metricName !== "string") {
                        console.error("isMetric expected a string, got a ", typeof metricName);
                        return false;
                    }
                    let metricIndex = self.getTitles().indexOf(metricName);
                    return metricIndex >= self.gridOptions.chartDataMapper.numAttributes;
                }
                //checks if the function is grouped or not
                //returns false for the last grouping in case of pivot
                self.isGrouped = function(params) {
                    let pivot_elements = self.getColumnStateMaster().columnPivotModel.getPivotColumnsInternal();
                    let grouped = params.node.group;
                    if(pivot_elements.length >= 1) {
                        let grouped_elements = self.getColumnStateMaster().columnRowGroupingModel.getRowGroupColumnsInternal();
                        if(params.node.field === grouped_elements[grouped_elements.length - 1]) {
                            return false;
                        }
                    }
                    return grouped;
                };
                self.getUpdatedColumnDefs = function() {
                    let columnDefs = self.defaultColumnDef;
                    vitaraLD.each(columnDefs, function(colDef) {
                        self.appendColStateToDef(colDef);
                    });
                    return columnDefs;
                }

                self.appendColStateToDef = function(colDef) {
                    let gridContext = this;
                    let colState = gridContext.getColumnStateMaster().getColumnStateById(colDef.colId);
                    if (colState === null) return; 
                    colDef.width = colState.width;
                    colDef.hide = colState.hide;
                    colDef.pinned = colState.pinned;
                    colDef.sort = colState.sort;
                    if (colDef.isMetric) {
                        colDef.aggFunc = colState.aggFunc;
                    }else {
                        colDef.rowGroupIndex = colState.rowGroupIndex;
                        colDef.pivotIndex = colState.pivotIndex;
                    }
                }

                var ColumnDefinition = function(name, title, isMetric, gridContext) {
                    var namelower = name;
                    var name = self.formatNames(name);
                    var defContext = self;   
                    let aggregation_helper = self.getAggregationHelper();
                    let valueGetter = aggregation_helper.genericValueGetter.bind(aggregation_helper);
                    let totalValueGetter = aggregation_helper.totalValueGetter.bind(aggregation_helper);
                    let columnModel =  gridContext.getColumnStateMaster();
                    let colId = name;
                    var columndef = {
                        colId,
                        headerName: self.formatNames(title),
                        headerTooltip: title,
                        isMetric: isMetric,
                        enableRowGroup: true,
                        enablePivot: true,
                        menuTabs: ['generalMenuTab','filterMenuTab','columnsMenuTab'],
                        lockPinned: false,
                        lockVisible: false,
                        sortable: true,
                        resizable: true,
                        filter: true,
                        comparator: function(valueA, valueB, nodeA, nodeB, inverted) {
                            return defContext.getSortingModel().customComparatorSelector(valueA, valueB, nodeA, nodeB, inverted, colId);
                        },
                        pivotComparator: function(valueA, valueB) {
                            return defContext.getSortingModel().customPivotComparator(valueA, valueB, this);
                        },
                        width: 200,
                        hide: false,
                        pinned: null,
                    };
                    if(isMetric) {
                        columndef.enableRowGroup = false;
                        columndef.enablePivot = false;
                        if(name === "Total") {
                            columndef.valueGetter = totalValueGetter;
                            columndef.vitaraTotalsField = true;
                        } else {
                            columndef.valueGetter = valueGetter;
                        }
                        columndef.aggFunc = "sum";
                    }
                    if(!isMetric) {
                        columndef.aggFunc = null;
                        columndef.rowGroupIndex = null;
                        columndef.pivotIndex = null;
                    }
                    if (!gridContext.gridOptions.enablePropMenu) {
                        columndef.suppressMenu = true;
                        columndef.suppressSorting = true;
                    }
                    self.appendColStateToDef(columndef);

                  
                    //Creating a pinned row cell renderer
                    var CustomPinnedRowRenderer = function() {}
                    self.CustomPinnedRowRenderer = CustomPinnedRowRenderer;
                    self.setCustomPinnedRowRenderer = params => {
                        if (params.node.rowPinned)
                            return {component : self.CustomPinnedRowRenderer}
                    }
                    self.CustomPinnedRowRenderer.prototype.init = function(params) {
                        let rendererContext = defContext.getDefaultRenderer();
                        let grandTotalsModel = defContext.getGrandTotalsModel();
                        let text_element = document.createElement("span"),
                        isNotTotalCol = params.colDef.headerName !== "Total" 
                            && Object.keys(params.data).indexOf(params.colDef.colId) > -1;
                        this.eGui = document.createElement('div');
                        this.eGui.innerHTML = "";
                        if(isNotTotalCol && !params.colDef.isMetric){
                            this.eGui.innerHTML = params.data[params.colDef.colId];
                        }
                        if(this.eGui.innerHTML === grandTotalsModel.getGrandTotalsText()) {
                            this.eGui.style["font-weight"] = grandTotalsModel.getGrandTotalsTextWeight();
                            this.eGui.style["text-decoration"] = grandTotalsModel.getGrandTotalsTextDecoration();
                            this.eGui.style["font-style"] = grandTotalsModel.getGrandTotalsTextStyle();
                            this.eGui.style["font-family"] = `'${grandTotalsModel.getGrandTotalsTextFamily()}'`;
                            this.eGui.style["font-size"] = grandTotalsModel.getGrandTotalsTextSize()+"px";
                            this.eGui.style["justify-content"] = grandTotalsModel.getGrandTotalsTextAlign();
                            this.eGui.style["align-items"] = grandTotalsModel.getGrandTotalsTextVerticalAlign();
                            this.eGui.style["color"] = grandTotalsModel.getGrandTotalsTextColor();
                        } else {
                            this.eGui.style["font-weight"] = grandTotalsModel.getGrandTotalsValueWeight();
                            this.eGui.style["text-decoration"]=grandTotalsModel.getGrandTotalsValueDecoration();
                            this.eGui.style["font-style"] = grandTotalsModel.getGrandTotalsValueStyle();
                            this.eGui.style["font-family"] = `'${grandTotalsModel.getGrandTotalsValueFamily()}'`;
                            this.eGui.style["font-size"] = grandTotalsModel.getGrandTotalsValueSize()+"px";
                            this.eGui.style["justify-content"] = grandTotalsModel.getGrandTotalsValueAlign();
                            this.eGui.style["text-align"] = (grandTotalsModel.getGrandTotalsValueAlign() === 'flex-end' ? 'right' : grandTotalsModel.getGrandTotalsValueAlign() === 'flex-start' ? 'left' : grandTotalsModel.getGrandTotalsValueAlign());
                            this.eGui.style["align-items"] = grandTotalsModel.getGrandTotalsValueVerticalAlign();
                            this.eGui.style["color"] = grandTotalsModel.getGrandTotalsValueColor();
                        }
                        if(this.eGui.innerHTML === grandTotalsModel.getGrandTotalsText()) {
                            vitaraJQ(this.eGui).addClass(" vitara-grand-totals-header ");
                            vitaraJQ(this.eGui).addClass(" vitara-grand-totals-text ");
                            vitaraJQ(params.eParentOfValue).css("background-color",grandTotalsModel.getGrandTotalsTextBgColor());
                            vitaraJQ(params.eParentOfValue).addClass(" vitara-grand-totals-header vitara-grand-totals-cell ");
                        } else {
                            vitaraJQ(this.eGui).addClass(" vitara-grand-totals-value ");
                            vitaraJQ(this.eGui).addClass(" vitara-grand-totals-text ");
                            vitaraJQ(params.eParentOfValue).css("background-color",grandTotalsModel.getGrandTotalsValueBgColor());
                            vitaraJQ(params.eParentOfValue).addClass(' vitara-grand-totals-value ');
                            vitaraJQ(params.eParentOfValue).addClass(' vitara-grand-totals-row ');
                            vitaraJQ(params.eParentOfValue).addClass(" vitara-grand-totals-value vitara-grand-totals-cell ");
                        }
                        this.eGui.style.display = "flex";
                        if (isNotTotalCol && params.colDef.isMetric) {
                            let opts = {
                                params: params,
                                elementValue: params.data?.[params.colDef.colId]?.rawValue,
                                element: this.eGui,
                                rowData: params.data, 
                                element_fv: params.data?.[params.colDef.colId]?.value,
                                metricName: params.colDef.colId,
                            };
                            let thresholds = rendererContext.thresholdRendererHelper(opts);
                            this.eGui = thresholds.element;
                            if (thresholds.wrapper) {
                                if (thresholds.barLabelWrapper) {
                                    thresholds.barLabelWrapper.append(thresholds.wrapper);
                                    this.eGui.append(thresholds.barLabelWrapper);
                                } else {
                                    this.eGui.append(thresholds.wrapper);
                                }
                            } else {
                                text_element.innerText = thresholds.elementValue ? opts.element_fv : "";
                                this.eGui.append(text_element);
                            }
                        }
                    };

                    self.CustomPinnedRowRenderer.prototype.getGui = function() {
                        return this.eGui;
                    };

                    //Floating CEll Renderer - Bottom Rows
                        //Reject if attribute
                    //Experimental style change

                    if (isMetric) {
                        columndef.enableValue = true;
                        columndef.field = name + '.rawValue';
                        columndef.filter = 'agNumberColumnFilter';
                        columndef.cellRenderer = self.getDefaultRenderer().rendererSelector;
                        columndef.filterValueGetter = params => {
                            return params.data?.[params.column?.colId]?.rawValue;
                        }
                    } else {
                        columndef.field = name;
                        columndef.filter = 'agTextColumnFilter';
                        columndef.cellRenderer = self.getDefaultRenderer().attributeRenderer;
                    }
                    columndef.cellRendererSelector = self.setCustomPinnedRowRenderer; 
                    // columndef.tooltipField = name;
                    columndef.tooltipComponent = 'customTooltip';
                    columndef.tooltipValueGetter = function (params) {
                        return params.value                        
                    };

                    return columndef;
                };

                var prepareColumnState = function(columnstate) {
                    var currentcolumnstate = gridOptions.columnApi.getColumnState();
                    var groupindex = currentcolumnstate.length;
                    if (self.groupedColumns.length > 0) {
                        for (var temp1 = 0; temp1 < self.groupedColumns.length; temp1++) {
                            var groupColumn = self.groupedColumns[temp1].columns;
                            for (var temp = 0; temp < groupColumn.length; temp++) {
                                var newIndex = currentcolumnstate.map(function(x) {
                                    return x.colId;
                                }).indexOf(groupColumn[temp]);
                                if (newIndex !== -1 && newIndex < groupindex) {
                                    groupindex = newIndex;
                                }
                            }
                        }
                    }
                    for (var temp = 0; temp < currentcolumnstate.length; temp++) {
                        var curcolumnstate = currentcolumnstate[temp];
                        var check = self.defaultColumnDef.filter(function(ob) {
                            return ob.colId == curcolumnstate.colId;
                        });
                        if (check.length == 0) {
                            currentcolumnstate.splice(temp, 1);
                        }
                        check = columnstate.filter(function(ob) {
                            return ob.colId == curcolumnstate.colId;
                        });
                        if(check.length > 0) {
                            check[0].aggFunc = check[0].aggFunc || curcolumnstate.aggFunc;
                            currentcolumnstate[temp].width = check[0].width;
                            currentcolumnstate[temp].aggFunc = check[0].aggFunc;
                        }
                    }
                    // var defaultColumn = currentcolumnstate;
                    var defaultColumn = currentcolumnstate.slice(0, groupindex);
                    var groupedColumn = currentcolumnstate.slice(groupindex);
                    for (var temp = 0; temp < self.groupedColumns.length; temp++) {
                        var groupColumn = self.groupedColumns[temp].columns;
                        for (var temp1 = 0; temp1 < groupColumn.length; temp1++) {
                            var filteredColState = groupedColumn.filter(function(ob) {
                                return ob.colId == groupColumn[temp1];
                            });
                            if (typeof filteredColState[0] !== 'undefined' && filteredColState[0] !== null && filteredColState[0] !== '') {
                                defaultColumn[defaultColumn.length] = filteredColState[0];
                            }
                        }
                    }
                    for (var temp = 0; temp < defaultColumn.length; temp++) {
                        var curcolumnstate = defaultColumn[temp];
                        var check = columnstate.filter(function(ob) {
                            return ob.colId == curcolumnstate.colId;
                        });
                        if (check.length > 0) {
                            defaultColumn[temp] = check[0];
                        }
                    }

                    var newcolstate;
                    if (gridOptions.hasOwnProperty("rowSelection")) {
                        newcolstate = columnstate.slice(0, columnstate.length);
                    } else {
                        newcolstate = currentcolumnstate.slice(0, columnstate.length);
                    }
                    //Default Last attribute index
                    var attributeLastIndex = 0;
                    //Find the index of last attribute
                    for (var temp = 0; temp < columnstate.length; temp++) {
                        var defColDef = self.defaultColumnDef.filter(function(ob) {
                            return ob.colId == columnstate[temp].colId;
                        });
                        if (defColDef && defColDef[0] && defColDef[0].isMetric == false) {
                            attributeLastIndex = temp + 1;
                        }
                    }
                    //This will compare the new columnstate with the old state
                    //If new state has any column new columns then the column is an
                    //attribute it gets added after the last attribute in old column state
                    //or Metric it gets added to last of the old column state
                    //Old state is used to retain the column rearranging property
                    for (var temp = 0; temp < defaultColumn.length; temp++) {
                        var curcolumnstate = defaultColumn[temp];
                        var index = newcolstate.map(function(x) {
                            return x.colId;
                        }).indexOf(curcolumnstate.colId);
                        if (index < 0) {
                            var defColDef = self.defaultColumnDef.filter(function(ob) {
                                return ob.colId == curcolumnstate.colId;
                            });
                            if (defColDef[0].isMetric == false) {
                                newcolstate.splice(attributeLastIndex, 0, defaultColumn[temp]);
                            } else {
                                newcolstate[newcolstate.length] = defaultColumn[temp];
                            }
                        }
                    }
                    for (var it in newcolstate) {
                        for (var it2 in columnstate) {
                            if (newcolstate[it].colId == columnstate[it2].colId) {
                                newcolstate[it].hide = columnstate[it2].hide;
                                break;
                            }
                        }
                    }
                    columnstate = newcolstate;
                    return columnstate;
                };

                self.callPrepareColumnState = prepareColumnState;

                var getColorHistory = function() {
                    //self.recentColors = JSON.parse(sessionStorage.getItem(self.saveColorHistoryKey)) || [];
                    return JSON.parse(sessionStorage.getItem(self.saveColorHistoryKey)) || [];
                };

                var saveToColorHistory = function() {
                    sessionStorage.setItem(self.saveColorHistoryKey, JSON.stringify(self.recentColors));
                };

                
                var sortNumber = function(a, b) {
                    return a - b;
                };
              

                self.setVitaraColorPicker = function(id, context, color) {
                    vitaraJQ(id, context).vitaracolorpicker({
                            showOn: 'button',
                            //initialHistory: self.recentColors,
                            color: color || '',
                            initialHistory: getColorHistory(),
                            customHistoryClose: true,
                            sliders: 'wv',
                            indicatorStyle: 'arrow',
                            defaultPalette: 'custom'
                        })
                        .off('changecolor').on('changecolor', updateRecentColors);
                };

                var updateRecentColors = function(evt, color) {
                    if (color) {
                        if (self.recentColors.length === 0) {
                            self.recentColors = getColorHistory();
                            if (self.recentColors.length > 9)
                                self.recentColors.splice(0, 1);
                            self.recentColors.push(color);
                        }
                        if (self.recentColors.length > 10)
                            self.recentColors.splice(10);
                        saveToColorHistory();
                        updateVitaraColorPickerHistory('#header_font_color');
                        updateVitaraColorPickerHistory('#body_font_color');
                        updateVitaraColorPickerHistory('.thresholdColorpicker');
                    }
                };

                var updateVitaraColorPickerHistory = function(id) {
                    try {
                        vitaraJQ(id, self.gridOptions.gridArea).vitaracolorpicker('updateHistory', self.recentColors);
                    } catch (error) {
                        console.log("update color failed");
                    }
                };

                var destroyVitaraColorPicker = function(id) {
                    try {
                        vitaraJQ(id, self.getPropMenuContainer()).vitaracolorpicker('destroy');
                    } catch (error) {
                        console.log("failed");
                    }
                };

              //Find proper place
                var getPopupLeftPosition = function(popUpWidth) {
                    var leftPosition = '34%';
                    if (!!document.documentMode || !!window.StyleMedia) {
                        //IE specific
                        if ((isMSTRDashBoard() || isMSTRDesktop()) && !isMSTRMobile()) {
                            //only in dashboards
                            if (vitaraJQ('.mstrmojo-VIDocLayout').length > 0) {
                                if (vitaraJQ('.mstrmojo-VIDocLayout')[0].getBoundingClientRect() && vitaraJQ('.mstrmojo-VIDocLayout')[0].getBoundingClientRect().right) {
                                    //right position of the div containing the charts
                                    leftPosition = vitaraJQ('.mstrmojo-VIDocLayout')[0].getBoundingClientRect().right;
                                } else {
                                    //Place to the left of the gallery
                                    if (vitaraJQ('.mstrmojo-RootView-gallery').length > 0) {
                                        var galleryWidth = vitaraJQ('.mstrmojo-RootView-gallery').width();
                                        if (galleryWidth) {
                                            leftPosition -= galleryWidth;
                                        }
                                    }
                                }
                            } else {
                                //Place to the extreme right
                                leftPosition = window.innerWidth;
                            }
                            //remove width of the popup
                            leftPosition -= (popUpWidth ? parseInt(popUpWidth) : parseInt(gridOptions.propMenuWidth));
                        }
                    }
                    return leftPosition;
                };

                self.callPopupLeftPosition = getPopupLeftPosition;

                //Check this function
                function provideDataToGrid(columnsData){
                    var state = {};
                    self.getColumnStateMaster().columnAggregationModel.fixaggregation();
                    self.getTrendingModel();
                    gridOptions.api.setRowData(columnsData.rowData);
                    let rowGroupOpened = self.getRowGroupOpenedModel();
                    if(self.getColumnStateMaster().columnRowGroupingModel.getRowGroupColumnsInternal().length > 0 && rowGroupOpened.getIsAnyRowGroupExpanded()) {
                        rowGroupOpened.drawRowGroupOpened();
                    }
                    self.getGrandTotalsModel().onGrandTotalsChange();
                    if (typeof state['exportToCSV'] !== 'undefined' && state['exportToCSV'] != '') {
                        if (state['exportToCSV']) {
                            var params = {
                                skipHeader: false,
                                skipFooters: false,
                                skipGroups: false,
                                allColumns: false,
                                fileName: gridOptions.id + '.csv',
                                columnSeparator: ','
                            };
                            gridOptions.api.exportDataAsCsv(params);
                            state['exportToCSV'] = false;
                        }
                    }
                }


                self.initiateGridAndRender = function() {
                    //Checking Grid Area
                    self.gridOptions = gridOptions;
                    if (gridOptions.gridArea !== null) {
                        self.getColumnStateMaster();
                        var columnsData = readGridDataAndDefiniton();
                        
                        // @@@@###
                        for (var temp = 0; temp < gridOptions.customIcons.length; temp++) {
                            var customicon = gridOptions.customIcons[temp];
                            self.icons[customicon['id']] = customicon['icons'];
                        }
                        //Assign Custom Main Menu items
                        gridOptions.getMainMenuItems = self.getHamBurgerMenu().getGridChartHamburgerMenu(self).getMainMenuItems;
                        gridOptions.autoGroupColumnDef = {
                            cellRenderer: 'agGroupCellRenderer',
                            cellRendererSelector: self.setCustomPinnedRowRenderer,
                            field: 'groupedCol',
                            filter: 'agGroupColumnFilter',
                            width: self.getColumnStateMaster().getSubStateValue("width", "ag-Grid-AutoColumn", 200),
                            resizable: true,
                            enablePivot: false,
                            enableRowGroup: false,
                            headerClass: "vitara-header vitara-grid-header-cell",
                            sortable:true,
                            pinned: self.getColumnStateMaster().getSubStateValue("pinned", "ag-Grid-AutoColumn", null),
                            menuTabs: ["generalMenuTab","filterMenuTab","columnsMenuTab"],
                            cellClass: function(params) {
                                let defaultClass = [" vitara-cell", "vitara-grid-cell", "vitara-grid-column", "vitara-context-menu-target"];
                                let grouped = self.isGrouped(params);
                                if(grouped) {
                                    let subtotalClasses = ["vitara-grid-subtotals-header", "vitara-grid-subtotals-cell"];
                                    defaultClass = [...defaultClass, ...subtotalClasses];
                                }
                                return defaultClass;
                            },
                            cellRendererParams:{
                                // innerRenderer: self.getDefaultRenderer().attributeRenderer,
                                suppressCount: self.getChildrenCountModel().isChildrenCountHidden(),
                                checkbox: self.getGridCheckboxModel().isGridCheckboxEnabled()
                            },
                            tooltipValueGetter: function (params) {
                                var count = params.node.allChildrenCount;
                                if (count !== null) {
                                    return `${params.value} (${count})`;
                                }
                                return params.value;
                            }
                        };
                    
                        gridOptions.defaultColDef = {
                            headerComponent: VitaraGridChartSimpleHeaderComponent,
                            headerClass: 'vitara-header vitara-grid-header-cell',
                            tooltipComponent: 'customTooltip',
                            cellClass: function(params) {
                                let defaultClass = [" vitara-cell", "vitara-grid-cell", "vitara-grid-column","vitara-context-menu-target"];
                                let grouped = self.isGrouped(params);
                                if(grouped) {
                                    let subtotalClasses = ["vitara-grid-subtotals-value", "vitara-grid-subtotals-cell"];
                                    defaultClass = [...defaultClass, ...subtotalClasses];
                                }
                                return defaultClass;
                            }
                        };

                        gridOptions.defaultColGroupDef = {
                            headerGroupComponent: CustomHeaderGroup,
                            headerClass: 'vitara-header vitara-grid-grouped-header-cell',
                        };
                        //Initializing the Grid
                        self.gridOptions = gridOptions;
                        initiateGrid(columnsData);
                        if(!gridOptions.dontPopulateData){
                            // provideDataToGrid(columnsData);
                            provideDataToGrid(columnsData);
                            let pivotModel = self.getColumnStateMaster().columnPivotModel;
                            self.getMetricToRowsModel().initMetricModel();
                            pivotModel.initSubModel();
                            self.getColumnStateMaster().columnShowHideModel.applyVisibilityWrapper();
                            self.getThresholdModel();
                            self.getFilterModel();
                        } else{
                            self.lazyDataSetter = function(){
                              provideDataToGrid(columnsData);
                            }
                        }

                    } else {
                        //There is no grid element specified
                        console.log('Invalid grid area');
                    }
                    self.gridOptions = gridOptions;
                };
            }; //end of function definition;

            vitaraJQ.extend(VitaraAgGrid.prototype, {

                getColumnMenu: function() {
                    if (!this.columnMenu) {
                        this.columnMenu = new VitaraGridChartColumnMenu(this);
                    }
                    return this.columnMenu;
                },
                getLegacyColumnMenu: function(state, menu) {
                    if(!this.legacyColumnMenu) {
                        this.legacyColumnMenu = new VitaraGridChartLegacyColumnMenu(state, menu);
                    }
                    return this.legacyColumnMenu;
                },
                getHamBurgerMenu: function() {
                    if (!this.hamburgerMenu) {
                        this.hamburgerMenu = new VitaraGridChartHamburgerMenu();
                    }
                    return this.hamburgerMenu;
                },
                getChartEventListener: function(contextMenuState, contextMenu) {
                    if (!this.chartEventListener) {
                        this.chartEventListener = new VitaraGridChartEventListeners(contextMenuState, contextMenu);
                    }
                    return this.chartEventListener;
                },
                getFilterThreshold: function(style) {
                    if (!this.filterThreshold) {
                        this.filterThreshold = new VitaraGridChartFilterThreshold(style);
                    }
                    return this.filterThreshold;
                },
                getColumnGrouping: function() {
                    if (!this.columnGrouping) {
                        this.columnGrouping = new VitaraGridChartColumnGroupingModel(this);
                    }
                    return this.columnGrouping;
                },
                  //To be later moved to another function for just one call
                getStateManager: function (){
                    if (!this.stateManager){
                        this.stateManager =  new VitaraStateManager(this);
                    }
                    return this.stateManager;
                  },
                getSortingModel: function(){
                    if (!this.sortChart){
                        this.sortChart = new VitaraGridChartSortingModel(this);
                    }
                    return this.sortChart;
                },
                getColumnStateMaster: function(){
                    if(!this.columnStateMaster){
                        this.columnStateMaster = new VitaraGridChartColumnStateMaster(this);
                    }
                    return this.columnStateMaster;
                  },
                getChildrenCountModel: function(){
                    if (!this.childrenCountModel){
                        this.childrenCountModel = new VitaraGridChartChildrenCountModel(this);                        
                    }                      
                    return this.childrenCountModel;
                },
                getColumnFormattingModel: function(){
                    if(!this.columnFormattingModel){
                        this.columnFormattingModel = new VitaraGridChartColumnFormattingModel(this);
                    }
                    return this.columnFormattingModel;
                },
                getThemeFormattingModel: function(){
                    if(!this.themeFormattingModel){
                        this.themeFormattingModel = new VitaraGridChartThemeFormattingModel(this);
                    }
                    return this.themeFormattingModel;
                },
                getAggregationWrapperModel: function(){
                    if(!this.aggregationWrapperModel){
                        this.aggregationWrapperModel = new VitaraGridChartAggregationWrapperModel(this);
                        this.aggregationWrapperModel._initAggregation();
                    }
                    return this.aggregationWrapperModel;
                },
                getAggregationHelper: function() {
                    if(!this.aggregationHelper) {
                        this.aggregationHelper = new VitaraGridChartAggregationHelper(this);
                    }
                    return this.aggregationHelper;
                },
                getGridOptions: function(){
                    return this.gridOptions;
                },
                getColumnGroupingView: function(){
                    if (!this.columnGroupingView){
                        this.columnGroupingView = new VitaraGridChartColumnGroupingView(this);
                    }
                    return this.columnGroupingView;
                },
                getVitaraGridPropertyEditorMapper: function(){
                    if (!this.vitaraGridPropertyEditorMapper) {
                        this.vitaraGridPropertyEditorMapper = new VitaraGridPropertyEditorMapper(this);
                    }
                    return this.vitaraGridPropertyEditorMapper;
                },
                getHeaderFormattingView: function(){
                    if(!this.headerFormattingView) {
                        this.headerFormattingView = new VitaraGridChartHeaderFormattingView(this);
                    }
                    return this.headerFormattingView;
                },
                getThresholdModel: function() {
                    if(!this.thresholdModel) {
                        this.thresholdModel = new VitaraGridChartThresholdModel(this, "thresholds");
                    }
                    return this.thresholdModel;
                },
                getFilterModel: function() {
                    if(!this.filterModel) {
                        this.filterModel = new VitaraGridChartThresholdModel(this, "filter");
                    }
                    return this.filterModel;
                },
                getEventDispatcher: function() {
                    if(!this.eventDispatcher) {
                        this.eventDispatcher = new VitaraGridChartEventDispatcher(this);
                    }
                    return this.eventDispatcher;
                },
                getChooseColumnModel: function() {
                    if(!this.chooseColumnModel) {
                        this.chooseColumnModel = new VitaraGridChartChooseColumnModel(this);
                    }
                    return this.chooseColumnModel;
                },
                getGrandTotalsModel: function() {
                    if(!this.grandTotalsModel) {
                        this.grandTotalsModel = new VitaraGridChartGrandTotalsModel(this);
                    }
                    return this.grandTotalsModel;
                 },
                 getSubTotalsModel: function() {
                    if(!this.subTotalsModel) {
                        this.subTotalsModel = new VitaraGridChartSubTotalsModel(this);
                    }
                    return this.subTotalsModel;
                 },
                 getThresholdView: function(chartArea) {
                    if(!this.thresholdView) {
                        this.thresholdView = new VitaraGridChartThresholdView(this, chartArea);
                    }
                    return this.thresholdView;
                 },
                 getRatioAggregationModel: function() {
                     if(!this.ratioAggregationModel) {
                         this.ratioAggregationModel = new VitaraGridChartRatioModel(this);
                     }
                     return this.ratioAggregationModel;
                 },
                 getRatioAggregationView: function() {
                     if(!this.ratioAggregationView) {
                         this.ratioAggregationView = new VitaraGridChartRatioView(this);
                     }
                     return this.ratioAggregationView;
                 },
                 getRowGroupOpenedModel: function() {
                     if(!this.rowGroupOpenedModel) {
                        this.rowGroupOpenedModel = new VitaraGridChartRowGroupOpenedModel(this);
                     }  
                     return this.rowGroupOpenedModel;
                 },
                 getColumnResizedModel: function() {
                     if(!this.columnResizeModel) {
                         this.columnResizeModel = new VitaraGridChartColumnResizeModel(this);
                     }
                     return this.columnResizeModel;
                 },
                 getGridThemeView: function() {
                    if(!this.gridThemeView) {
                        this.gridThemeView = new VitaraGridChartGridThemeView(this);
                    }
                    return this.gridThemeView;
                 },
                 getFormatColumnView: function(customHandlerContext) {
                    if(!this.formatColumnView) {
                        this.formatColumnView = new VitaraGridChartFormatColumnView(this, customHandlerContext);
                    }
                    return this.formatColumnView;
                 },
                 getThemeModel: function() {
                     if(!this.themeModel) {
                         this.themeModel = new VitaraGridChartGridThemeModel(this);
                     }
                     return this.themeModel;
                 },
                 getMicroChartTypeModel: function() {
                     if(!this.microChartTypeModel) {
                         this.microChartTypeModel = new VitaraMicroChartTypeModel(this);
                     }
                     return this.microChartTypeModel;
                 },
                 getPlotTypeSelectorModel: function() {
                     if(!this.plotTypeSelectorModel) {
                         this.plotTypeSelectorModel = new VitaraMicroChartPlotTypeSelectorModel(this);
                     }
                     return this.plotTypeSelectorModel;
                 },
                getPivotDropZoneModel: function() {
                     if(!this.pivotDropZoneModel) {
                         this.pivotDropZoneModel =  new VitaraGridChartPivotDropZoneModel(this);
                     }
                     return this.pivotDropZoneModel;
                 },
                 getGroupingDropZoneModel: function() {
                     if(!this.groupingDropZoneModel) {
                         this.groupingDropZoneModel = new VitaraGridChartGroupingDropZoneModel(this);
                     }
                     return this.groupingDropZoneModel;
                 },
                
                 getRowSelectedModel: function() {
                     if(!this.rowSelectedModel) {
                         this.rowSelectedModel = new VitaraGridChartRowSelectedModel(this);
                     }
                     return this.rowSelectedModel;
                 },
                 getChartTypeModel : function() {
                    if(!this.chartTypeModel) {
                        this.chartTypeModel =  new VitaraChartTypeModel(this, "GridChart");
                    }
                    return this.chartTypeModel;
                 },
                 getPropertyEditorRTLLayoutModel: function() {
                     if(!this.propertyEditorRTLModel) {
                         this.propertyEditorRTLModel = new VitaraGridChartPropertyEditorRTLLayoutModel(this);
                     }
                     return this.propertyEditorRTLModel;
                 },
                 getExportToCSV: function() {
                     if(!this.exportToCSV) {
                         this.exportToCSV = new VitaraGridChartExportToCSV(this);
                     }
                     return this.exportToCSV;
                 },
                 getFilterView: function() {
                     if(!this.filterView) {
                         this.filterView = new VitaraGridChartFilterView(this);
                     }
                     return this.filterView;
                 },
                 getColumnOrderModel: function() {
                     if(!this.columnOrderModel) {
                        this.columnOrderModel = new VitaraGridChartColumnOrderModel(this);
                     }
                     return this.columnOrderModel;
                 },
                 getMetricToRowsModel: function() {
                     if(!this.metricToRowsModel) {
                         this.metricToRowsModel = new VitaraGridChartMetricToRowsModel(this);
                     }
                     return this.metricToRowsModel;
                 },
                  getCustomTooltipModel: function() {
                      if(!this.customTooltipModel) {
                          this.customTooltipModel = new VitaraGridChartCustomTooltipModel(this);
                      }
                      return this.customTooltipModel;
                  },
                  getTrendingModel: function() {
                      if(!this.trendingModel) {
                          this.trendingModel = new VitaraGridChartTrendingModel(this);
                      }
                      return this.trendingModel;
                  },
                getScalingModel: function() {
                    if(!this.scalingModel) {
                        this.scalingModel = new VitaraGridChartScalingModel(this);
                    }
                    return this.scalingModel;
                },
                getScalingView: function() {
                    if(!this.scalingView) {
                        this.scalingView = new VitaraGridChartScalingView(this);
                    }
                    return this.scalingView;
                },
                getMetricGroupingModel: function() {
                    if(!this.metricGroupingModel) {
                        this.metricGroupingModel = new VitaraGridChartMetricGroupingModel(this);
                    }
                    return this.metricGroupingModel;
                },
                getMetricGroupingView: function() {
                    if(!this.metricGroupingView) {
                        this.metricGroupingView = new VitaraGridChartMetricGroupingView(this);
                    }
                    return this.metricGroupingView;
                },
                getDragDropManager: function(options) {
                    if(this.dragDropManager) {
                        this.dragDropManager = null;
                    }
                    this.dragDropManager = new VitaraGridChartDragDropManager(options);
                    return this.dragDropManager;
                },
                  getTrendlineRenderer: function() {
                      if(!this.trendlineRenderer) {
                          this.trendlineRenderer = new VitaraGridChartTrendlineRenderer(this);
                      }
                      return this.trendlineRenderer;
                  },
                  getTrendlineOptionsView: function() {
                      if(!this.trendlineOptionsView) {
                          this.trendlineOptionsView = new VitaraGridChartTrendlineOptionsView(this);
                      }
                      return this.trendlineOptionsView;
                  },
                  getAnimationModel: function() {
                      if(!this.animationModel) {
                          this.animationModel = new VitaraGridChartAnimationModel(this);
                      }
                      return this.animationModel;
                  },
                  getAllowUrlsToVisualModel: function() {
                    if(!this.allowUrlsToVisualModel) {
                        this.allowUrlsToVisualModel = new VitaraGridChartAllowURLsModel(this);
                    }
                    return this.allowUrlsToVisualModel;
                  },
                  getGridCheckboxModel: function() {
                      if(!this.gridCheckboxModel) {
                          this.gridCheckboxModel = new VitaraGridChartCheckboxModel(this);
                      }
                      return this.gridCheckboxModel;
                  },
                  getColumnGroupOpenedModel: function() {
                      if(!this.columnGroupOpenedModel) {
                          this.columnGroupOpenedModel = new VitaraGridChartColumnGroupOpenedModel(this);
                      }
                      return this.columnGroupOpenedModel;
                  },
                  getCustomMarkerModel: function() {
                      if(!this.customMarkerModel) {
                          this.customMarkerModel = new VitaraGridChartCustomMarkerModel(this);
                      }
                      return this.customMarkerModel;
                  },
                  getShowDetailRowsModel: function() {
                    if(!this.showDetailRowsModel) {
                        this.showDetailRowsModel = new VitaraMicroChartShowDetailRowsModel(this);
                    }
                    return this.showDetailRowsModel;
                  },
                  getSortingView: function() {
                      if(!this.sortingView) {
                          this.sortingView = new VitaraGridChartSortingView(this);
                      }
                      return this.sortingView;
                  },
                  getGrandTotalsView: function(context) {
                      if(!this.grandTotalsView) {
                          this.grandTotalsView = new VitaraGridChartGrandTotalsView(this, context);
                      }
                      return this.grandTotalsView;
                  },
                  getSubTotalsView: function(context) {
                      if(!this.subTotalsView) {
                          this.subTotalsView = new VitaraGridChartSubTotalsView(this, context);
                      }
                      return this.subTotalsView;
                  },
                  getCustomMarkerView: function() {
                      if(!this.customMarkerView) {
                          this.customMarkerView = new VitaraGridChartCustomMarkerView(this);
                      }
                      return this.customMarkerView;
                  },
                  getDefaultRenderer: function() {
                      if(!this.defaultRenderer) {
                          this.defaultRenderer = new VitaraGridChartDefaultRenderer(this);
                      }
                      return this.defaultRenderer;
                  },
                  getCustomFormatEditor: function(){
                    if(!this.customFormatEditor){
                        this.customFormatEditor = new VitaraGridCustomFormattingEditor(this);
                    }
                    return this.customFormatEditor;
                  },
                  getCustomFormatEditorModel: function(){
                    if(!this.customFormatEditorModel){
                        this.customFormatEditorModel = new CustomFormattingEditorModel(this);
                    }
                    return this.customFormatEditorModel;
                  },
                  getColumnSelectionModel: function(){
                    if(!this.columnSelectionModel){
                        this.columnSelectionModel = new ColumnSelectionModel(this);
                    }
                    return this.columnSelectionModel;
                  }

            });
            export {VitaraAgGrid as vitaraGridHelper};