	import { utils } from "../../../../../../../VitaraCoreSource/javascript/utils";
	import AttributeThresholdHelper from "./AttributeThresholdHelper";

	 if (!mstrmojo.plugins.VitaraCharts.v527126) {
 		mstrmojo.plugins.VitaraCharts.v527126 = {};
 	}
 	if (!mstrmojo.plugins.VitaraCharts.v527126.helper) {
 		mstrmojo.plugins.VitaraCharts.v527126.helper = {};
 	}
 	if (!mstrmojo.plugins.VitaraCharts.v527126.helper.thresholds) {
 		mstrmojo.plugins.VitaraCharts.v527126.helper.thresholds = {};
 	}

 	var thresholdHelper = function(chartDataMapper) {
 		this.chartDataMapper = chartDataMapper;
		this.useTargetIndex = false;
 	};

 	thresholdHelper.prototype = {
 		scriptClass: "mstrmojo.plugins.VitaraCharts.v527126.helper.thresholds.thresholdHelper",
 		ENUM_THRESHOLD_OPTIONS: {
			EQUAL_TO: 'equalto',
			NOT_EQUAL_TO: 'notequalto',
 			GREATER_THAN: 'greaterthan',
 			LESS_THAN: 'lessthan',
 			GREATER_THAN_EQUAL_TO: 'greaterthanequalto',
 			LESS_THAN_EQUAL_TO: 'lessthanequalto',
 			BETWEEN: 'between',
 			TOP: 'top',
 			BOTTOM: 'bottom',
 			TOP_PERCENTAGE: 'toppercentage',
 			BOTTOM_PERCENTAGE: 'bottompercentage',
 			BETWEEN_PERCENTAGE: 'betweenpercentage',
 			ABOVE_AVERAGE: 'aboveaverage',
			BELOW_AVERAGE: 'belowaverage',
			ABOVE_THE_LINE: 'abovetheline',
			BELOW_THE_LINE: 'belowtheline'
 		},
 		ENUM_SORT_TYPE: {
 			ASC: 'ascending',
 			DESC: 'descending'
 		},
 		getChartDataMapper: function() {
 			return this.chartDataMapper;
 		},
 		setChartDataMapper: function(chartDataMapper) {
 			this.chartDataMapper = chartDataMapper;
 		},
		setTargetIndexUsage: function (value) {
			this.useTargetIndex = value;
		},
		getTargetIndexUsage: function() {
			return this.useTargetIndex;
		},		
 		isSeriesByMetric: function() {
 			if (this.chartDataMapper.seriesBy === this.chartDataMapper.MSTR_TYPE_METRIC) {
 				return true;
 			}
 			return false;
		},
		isSeriesByAttribute: function(attrTitle) {
			if (this.isSeriesByMetric()) {
				return false;
			}
			return vitaraLD.findIndex(this.getChartDataMapper().seriesElements, function(elem) {
				return elem.name === attrTitle;
			}) !== -1;
		},
 		getTargetMetricIndex: function(metricName, isMetricSeries, threshold) {
 			if (this.isSeriesByMetric() || isMetricSeries) {
				let mTargetIndex = -1;
				if (threshold && threshold.targetId) {
					mTargetIndex = this.getChartDataMapper().getColumnIndexById(threshold.targetId);
				}
				if (mTargetIndex !== -1) {
					return mTargetIndex;
				}
 				return this.chartDataMapper.getColumnIndex(metricName, this.chartDataMapper.originalTitles);
 			} else {
 				return this.chartDataMapper.numAttributes;
 			}
		},
		equalToFilter: function (threshold, sourceIndex, targetIndex, valueMarker, row) {
			if(row[sourceIndex]) 
				return row[sourceIndex][valueMarker]== threshold.values[0];
			else
				return row[valueMarker] == threshold.values[0];
 		},
 		greaterthanFilter: function(threshold, sourceIndex, targetIndex, valueMarker, row) {
			if(row[sourceIndex]) 
				return row[sourceIndex][valueMarker]> threshold.values[0];
			else
				return row[valueMarker] > threshold.values[0];							
 		},
 		lessthanFilter: function(threshold, sourceIndex, targetIndex, valueMarker, row) {
			if(row[sourceIndex]) 
				return row[sourceIndex][valueMarker]< threshold.values[0];
			else
				return row[valueMarker] < threshold.values[0];
 		},
 		greaterthanEqualToFilter: function(threshold, sourceIndex, targetIndex, valueMarker, row) {
			if(row[sourceIndex]) 
				return row[sourceIndex][valueMarker] >= threshold.values[0];
			else
				return row[valueMarker] >= threshold.values[0];							
 		},
 		lessthanEqualToFilter: function(threshold, sourceIndex, targetIndex, valueMarker, row) {
			if(row[sourceIndex]) 
				return row[sourceIndex][valueMarker] <= threshold.values[0];
			else
				return row[valueMarker] <= threshold.values[0];
 		},
 		betweenFilter: function(threshold, sourceIndex, targetIndex, valueMarker, row) {
			if(row[sourceIndex]) 
				return ((row[sourceIndex][valueMarker]>= threshold.values[0]) && (row[sourceIndex][valueMarker] <= threshold.values[1]));
			else
				return ((row[valueMarker] >= threshold.values[0]) && (row[valueMarker] <= threshold.values[1]));							
 		},
 		filterUniqueValues: function(value, index, cArray) {
 			return (cArray.indexOf(value) == index);
 		},
 		getTopXValues: function(sort, x, sourceIndex, targetIndex, targetName, valueMarker, dataRows) {
 			var targetValues = [],
			 	targetRows = [];
			if(!valueMarker) 
				valueMarker = 'v';
 			//var isSeriesByMetric = this.isSeriesByMetric();
			if(!dataRows) 
				dataRows =  this.chartDataMapper.dataRows;
 			if (sort === this.ENUM_SORT_TYPE.ASC) {
 				targetRows = dataRows.sort(function(a, b) {
					if (a[sourceIndex])
						return a[sourceIndex][valueMarker] - b[sourceIndex][valueMarker];
					return a[valueMarker] - b[valueMarker];
 				});
 			} else if (sort === this.ENUM_SORT_TYPE.DESC) {
 				targetRows = dataRows.sort(function(a, b) {
					if(b[sourceIndex])
						return b[sourceIndex][valueMarker] - a[sourceIndex][valueMarker];
 					return b[valueMarker] - a[valueMarker];
 				});
 			}
 			targetRows = targetRows.slice(0, x);
			targetValues = this.getValuesAtIndexFromRows(targetRows, targetIndex, "undefined", targetName, valueMarker, sourceIndex); 
			return targetValues;
 		},
 		getValuesAtIndexFromRows: function(filteredRows, targetIndex, isSeriesByMetric, targetName, valueMarker, sourceIndex) {
			var values = [];
			if(!valueMarker)
				valueMarker = 'v';
 			if (filteredRows && filteredRows.length) {
 				for (var i = 0; i < filteredRows.length; i++) {
					if(filteredRows[i][sourceIndex]) {
//						var colIndex = filteredRows[i].length - 1;
						values.push(filteredRows[i][sourceIndex][valueMarker]);
//						values.push(filteredRows[i][colIndex]['rowIndex']);
//						values.push(filteredRows[i][targetIndex][valueMarker]);
					}else{
						values.push(filteredRows[i][valueMarker]);
					}
											
					//commenting as target values are marked globally.
					/*if (isSeriesByMetric) {
						values.push(filteredRows[i][targetIndex].v);
					} else {
						if (filteredRows[i][targetIndex]['sn'] === targetName) {
							values.push(filteredRows[i][targetIndex].v);
						}
					}*/
 				}
 			}
 			return values;
 		},
 		getSourceMeanValue: function(sourceIndex, dataRows, valueMarker){
			if(!dataRows)
				dataRows = this.chartDataMapper.dataRows;
			if(!valueMarker)
				valueMarker = 'v';
			if (dataRows[0][dataRows[0].length - 1] && dataRows[0][dataRows[0].length - 1]['data'] && dataRows[0][dataRows[0].length - 1]['data']['metaInfo'] && dataRows[0][dataRows[0].length - 1]['data']['metaInfo'])
				return dataRows[0][dataRows[0].length - 1]['data']['metaInfo'][sourceIndex]['meanValue'];
			else
				return vitaraD3.mean(dataRows, function(d) {
					return d[sourceIndex] ? +d[sourceIndex][valueMarker] : +d[valueMarker];
				});
		},
		getTargetThresholdValues: function(threshold, sourceIndex, targetIndex, filter, targetName, valueMarker, sourceData) {
			 var self = this;
			if(!valueMarker)
 				valueMarker = 'v';
 			var targetValues = [];
			 var dataRows = sourceData ? sourceData.slice(0, sourceData.length) : this.chartDataMapper.dataRows.slice(0, this.chartDataMapper.dataRows.length);
			// var dataRows = vitaraLD.cloneDeep(sourceData? sourceData: this.chartDataMapper.dataRows);
 			//var isSeriesByMetric = this.isSeriesByMetric();
			 var isSeriesByMetric = null; 
			 if (dataRows && dataRows.length) {
				 if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.EQUAL_TO || threshold.condition === this.ENUM_THRESHOLD_OPTIONS.GREATER_THAN || threshold.condition === this.ENUM_THRESHOLD_OPTIONS.LESS_THAN 
					|| threshold.condition === this.ENUM_THRESHOLD_OPTIONS.GREATER_THAN_EQUAL_TO || threshold.condition === this.ENUM_THRESHOLD_OPTIONS.LESS_THAN_EQUAL_TO || threshold.condition === this.ENUM_THRESHOLD_OPTIONS.BETWEEN) {
 					var filteredRows = dataRows.filter(filter.bind(null, threshold, sourceIndex, targetIndex, valueMarker));
 					return this.getValuesAtIndexFromRows(filteredRows, targetIndex, isSeriesByMetric, targetName, valueMarker, sourceIndex);
 				} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.TOP) {
 					return this.getTopXValues(this.ENUM_SORT_TYPE.DESC, threshold.values[0], sourceIndex, targetIndex, targetName, valueMarker, dataRows);
 				} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.BOTTOM) {
 					return this.getTopXValues(this.ENUM_SORT_TYPE.ASC, threshold.values[0], sourceIndex, targetIndex, targetName, valueMarker, dataRows);
 				} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.TOP_PERCENTAGE){
 					var topXPercent = threshold.values[0];
 					var xPercentLength = Math.ceil(dataRows.length/100*topXPercent);
					dataRows.sort(function(a, b) {
						if(b[sourceIndex])
							return b[sourceIndex][valueMarker] - a[sourceIndex][valueMarker];
						else
							return b[valueMarker] - a[valueMarker];
					});
					var filteredRows = dataRows.slice(0, xPercentLength);
					return this.getValuesAtIndexFromRows(filteredRows, targetIndex, isSeriesByMetric, targetName, valueMarker, sourceIndex);
 				} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.BOTTOM_PERCENTAGE){
 					var btmXPercent = threshold.values[0];
 					var xPercentLength = Math.ceil(dataRows.length/100*btmXPercent);
 					dataRows.sort(function(a, b) {
						if (a[sourceIndex])
							return a[sourceIndex][valueMarker] - b[sourceIndex][valueMarker];
						else
							return a[valueMarker] - b[valueMarker];
					});
					var filteredRows = dataRows.slice(0, xPercentLength);
					return this.getValuesAtIndexFromRows(filteredRows, targetIndex, isSeriesByMetric, targetName, valueMarker, sourceIndex);
 				} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.BETWEEN_PERCENTAGE){
 					var fromXPercent = threshold.values[0], toXPercent = threshold.values[1] - threshold.values[0];
 					var fromLength = Math.floor(dataRows.length/100*fromXPercent), toLength = Math.ceil(dataRows.length/100*toXPercent);
					dataRows.sort(function(a, b) {
						if(a[sourceIndex])
							return a[sourceIndex][valueMarker] - b[sourceIndex][valueMarker];
						else
							return a[valueMarker] - b[valueMarker];
					});
					var filteredRows = dataRows.splice(fromLength, toLength);
					return this.getValuesAtIndexFromRows(filteredRows, targetIndex, isSeriesByMetric, targetName, valueMarker, sourceIndex);
 				} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.ABOVE_AVERAGE){
 					var average = this.getSourceMeanValue(sourceIndex, dataRows, valueMarker);
 					var targetValues = [];
 					for (var i=0; i<dataRows.length; i++){
						if (this.getTargetIndexUsage()) {
							if (dataRows[i][targetIndex]) {
								if (dataRows[i][targetIndex][valueMarker] > average) {
									targetValues.push(dataRows[i][targetIndex][valueMarker]);
								}
							}
						} else {
							if (dataRows[i][sourceIndex]) {
								if (dataRows[i][sourceIndex][valueMarker] > average) {
									targetValues.push(dataRows[i][sourceIndex][valueMarker]);
								}
							} else {
								if (dataRows[i][valueMarker] > average) {
									targetValues.push(dataRows[i][valueMarker]);
								}
							}
						}
 					}
 					return targetValues;
 				} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.BELOW_AVERAGE){
 					var average = this.getSourceMeanValue(sourceIndex, dataRows, valueMarker);
 					var targetValues = [];
 					for (var i=0; i<dataRows.length; i++){
						if (this.getTargetIndexUsage()) {
							if (dataRows[i][targetIndex]) {
								if (dataRows[i][targetIndex][valueMarker] < average) {
									targetValues.push(dataRows[i][targetIndex][valueMarker]);
								}
							}
						} else {
							if (dataRows[i][sourceIndex]) {
								if (dataRows[i][sourceIndex][valueMarker] < average) {
									targetValues.push(dataRows[i][sourceIndex][valueMarker]);
								}
							} else {
								if (dataRows[i][valueMarker] < average) {
									targetValues.push(dataRows[i][valueMarker]);
								}
							}
						}
 					}
 					return targetValues;
 				} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.NOT_EQUAL_TO) {
					var targetValues = [];
 					for (var i=0; i<dataRows.length; i++){
							if (dataRows[i][sourceIndex]) {
								if (dataRows[i][sourceIndex][valueMarker] !== threshold.values[0]) {
									targetValues.push(dataRows[i][sourceIndex][valueMarker]);
							}
						}else{
							if (dataRows[i][valueMarker] !== threshold.values[0]) {
								targetValues.push(dataRows[i][valueMarker]);
							}
						}
 					}
					return targetValues;
				}
 				if (targetRows && targetRows.length) {
 					for (var i = 0; i < targetRows.length; i++) {
 						targetValues.push(targetRows[i][targetIndex][valueMarker]);
 					}
 				}
 			}
 			return targetValues;
		 },
		isNumber: function (obj) {
			return obj !== undefined && typeof (obj) === 'number' && !isNaN(obj);
		},
		updateValuesForPercentageMetric: function(threshold, sourceIndex){
			if (threshold.condition !== this.ENUM_THRESHOLD_OPTIONS.TOP && threshold.condition !== this.ENUM_THRESHOLD_OPTIONS.BOTTOM && threshold.condition.indexOf('percentage') < 0) {
				if(sourceIndex === undefined){
					sourceIndex = this.chartDataMapper.getTitles().indexOf(threshold.source);
				}
				if(this.chartDataMapper.isMetricOfPercentageData){
					if(this.chartDataMapper.isMetricOfPercentageData(sourceIndex)){
						threshold.values = threshold.values.map(v => v/100);
					}
				}
				else{
					let mInfo = [{},{}];
					mInfo = this.chartDataMapper.updateMetricMetaInfo?.(mInfo);
					if(sourceIndex > -1 && mInfo[sourceIndex]?.isPercentageData){ // sourceIndex : -1 for ratio
						threshold.values = threshold.values.map(v => v/100);
					}
				}
			}
			return threshold;
		},
 		computeThreshold: function(thresholds, sourceIndex, targetIndex, targetName, valueMarker, sourceData) {
			var threshold = vitaraLD.cloneDeep(thresholds);
			var condition = threshold.condition;
			var targetValues = [];
			threshold = this.updateValuesForPercentageMetric(threshold, sourceIndex);
			if (condition === this.ENUM_THRESHOLD_OPTIONS.EQUAL_TO) {
				targetValues = threshold.values;
 			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.GREATER_THAN) {
 				targetValues = this.getTargetThresholdValues(threshold, sourceIndex, targetIndex, this.greaterthanFilter, targetName, valueMarker, sourceData);
 			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.LESS_THAN) {
 				targetValues = this.getTargetThresholdValues(threshold, sourceIndex, targetIndex, this.lessthanFilter, targetName, valueMarker, sourceData);
			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.GREATER_THAN_EQUAL_TO) {
				targetValues = this.getTargetThresholdValues(threshold, sourceIndex, targetIndex, this.greaterthanEqualToFilter, targetName, valueMarker, sourceData);
			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.LESS_THAN_EQUAL_TO) {
				targetValues = this.getTargetThresholdValues(threshold, sourceIndex, targetIndex, this.lessthanEqualToFilter, targetName, valueMarker, sourceData);
			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.BETWEEN) {
 				targetValues = this.getTargetThresholdValues(threshold, sourceIndex, targetIndex, this.betweenFilter, targetName, valueMarker, sourceData);
 			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.TOP) {
 				targetValues = this.getTargetThresholdValues(threshold, sourceIndex, targetIndex, null, targetName, valueMarker, sourceData);
 			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.BOTTOM) {
 				targetValues = this.getTargetThresholdValues(threshold, sourceIndex, targetIndex, null, targetName, valueMarker, sourceData);
 			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.TOP_PERCENTAGE){
 				targetValues = this.getTargetThresholdValues(threshold, sourceIndex, targetIndex, null, targetName, valueMarker, sourceData);
 			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.BOTTOM_PERCENTAGE){
 				targetValues = this.getTargetThresholdValues(threshold, sourceIndex, targetIndex, null, targetName, valueMarker, sourceData);
 			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.BETWEEN_PERCENTAGE){
 				targetValues = this.getTargetThresholdValues(threshold, sourceIndex, targetIndex, null, targetName, valueMarker, sourceData);
 			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.ABOVE_AVERAGE){
 				targetValues = this.getTargetThresholdValues(threshold, sourceIndex, targetIndex, null, targetName, valueMarker, sourceData);
 			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.BELOW_AVERAGE){
 				targetValues = this.getTargetThresholdValues(threshold, sourceIndex, targetIndex, null, targetName, valueMarker, sourceData);
 			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.NOT_EQUAL_TO) {
				targetValues = this.getTargetThresholdValues(threshold, sourceIndex, targetIndex, null, targetName, valueMarker, sourceData);
 			}
 			return targetValues.filter(this.isNumber);
		 },
		 computeThresholdRange: function (thresholds, sourceIndex, targetName, rangePoints) {
			var targetValues = [];
			let threshold = vitaraLD.cloneDeep(thresholds);
			threshold = this.updateValuesForPercentageMetric(threshold, sourceIndex);
			var min = rangePoints.minValue,
				max = rangePoints.maxValue;
			if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.EQUAL_TO) {
				targetValues[0] = threshold.values[0];
				targetValues[1] = threshold.values[0];
			} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.GREATER_THAN || threshold.condition === this.ENUM_THRESHOLD_OPTIONS.GREATER_THAN_EQUAL_TO) {
				targetValues[0] = threshold.values[0];
				targetValues[1] = threshold.values[0] < max ? max : threshold.values[0];
			} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.LESS_THAN || threshold.condition === this.ENUM_THRESHOLD_OPTIONS.LESS_THAN_EQUAL_TO) {
				targetValues[0] = min < threshold.values[0] ? min : threshold.values[0];
				targetValues[1] = threshold.values[0];
			} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.BETWEEN) {
				targetValues[0] = threshold.values[0];
				targetValues[1] = threshold.values[1];
			} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.TOP) {
				targetValues[0] = max - threshold.values[0];
				targetValues[1] = max;
			} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.BOTTOM) {
				targetValues[0] = min;
				targetValues[1] = min + threshold.values[0];
			} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.TOP_PERCENTAGE) {
				targetValues[0] = max - (threshold.values[0]/100)*(max-min);
				targetValues[1] = max;
			} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.BOTTOM_PERCENTAGE) {
				targetValues[0] = min;
				targetValues[1] = min + (threshold.values[0]/100)*(max-min);
			} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.BETWEEN_PERCENTAGE) {
				targetValues[0] = min + (threshold.values[0]/100)*(max-min);
				targetValues[1] = min + (threshold.values[1]/100)*(max-min);
			} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.ABOVE_AVERAGE) {
				targetValues[0] = this.getSourceMeanValue(sourceIndex);
				targetValues[1] = max;
			} else if (threshold.condition === this.ENUM_THRESHOLD_OPTIONS.BELOW_AVERAGE) {
				targetValues[0] = min;
				targetValues[1] = this.getSourceMeanValue(sourceIndex);
			}
			return targetValues;
		},
		computeThresholdValue: function(thresholds, targetValue) {
			if(typeof targetValue === "undefined"){
				return [];
			}
			var threshold = vitaraLD.cloneDeep(thresholds);
			var condition = threshold.condition;
			threshold = this.updateValuesForPercentageMetric(threshold);
			if (condition === this.ENUM_THRESHOLD_OPTIONS.EQUAL_TO) {
				if(targetValue === threshold.values[0])
					return [targetValue];
 			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.GREATER_THAN) {
				if(targetValue > threshold.values[0])
					return [targetValue];
 			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.LESS_THAN) {
				if(targetValue < threshold.values[0])
					return [targetValue];
			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.GREATER_THAN_EQUAL_TO) {
				if (targetValue >= threshold.values[0])
					return [targetValue];
			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.LESS_THAN_EQUAL_TO) {
				if (targetValue <= threshold.values[0])
					return [targetValue];
			} else if (condition === this.ENUM_THRESHOLD_OPTIONS.BETWEEN) {
				if(targetValue >= threshold.values[0] && targetValue <= threshold.values[1])
					return [targetValue];
 			}
 			return [];
		 },

 	};

 	//wrapper class
 	var ThresholdHelper = function(thresholdMapper, context) {
 		this.context = context;
 		this.thresholdMapper = thresholdMapper;
 	};

 	ThresholdHelper.prototype = {
		ENUM_THRESHOLD_TYPE: {
			PLOT_LINE: 'plotLine',
			ATTRIBUTE: 'attribute'
		},
		 pickFromSource: false,
		ENUM_THRESHOLD_COL_TYPE: {
			INVALD: 0,
			GRID_COL: 1,
			CHART_COL: 2,
		},
		SMALL_MULTIPLES_Titles: [],
 		getChartDataMapper: function() {
 			if (!this.chartDataMapper) {
				 //throw new Error("Cannot get chartDataMapper");
				 console.log("Cannot get chartDataMapper");
 			}
 			return this.chartDataMapper;
 		},
 		setChartDataMapper: function(chartDataMapper) {
			this.chartDataMapper = chartDataMapper;
			if (this.getAttributeThresholdHelper()) {
				this.getAttributeThresholdHelper().setChartDataMapper(chartDataMapper);
			}
 		},
 		getThresholdMapper: function() {
 			if (!this.thresholdMapper) {
 				throw new Error(utils.getCustomErrorCode('E0027'));
 			}
 			return this.thresholdMapper;
 		},
 		setThresholdMapper: function(thresholdMapper) {
 			this.thresholdMapper = thresholdMapper;
 		},
 		getThresholdHelper: function() {
 			if (!this.thresholdHelper) {
 				this.thresholdHelper = new thresholdHelper(this.getChartDataMapper());
 			}
 			return this.thresholdHelper;
		},
		getAttributeThresholdHelper: function() {
			if (!this.attrThresholdHelper) {
				this.attrThresholdHelper = new AttributeThresholdHelper(this.getChartDataMapper());
			}
			return this.attrThresholdHelper;
		},
		setPlotLineThreshold: function(targetData, threshold, chartOptions){
			if (!threshold.type === this.ENUM_THRESHOLD_TYPE.PLOT_LINE){
				return;
			}
			var plotLine = this.getPlotLineByLabel(threshold.source, chartOptions? chartOptions.plotLines : null);
			var sourceIndex = this.chartDataMapper.getColumnIndex(targetData.name, this.chartDataMapper.originalTitles);
			threshold.plValue = plotLine.cValue;
			if (threshold.color || threshold.markerType || threshold.enableDataLabel) {
				threshold.targetValues = this.getThresholdMapper().getPlotLineTargetPoints(targetData, threshold);
				this.getThresholdMapper().setThreshold(targetData, threshold.targetValues, threshold, sourceIndex, chartOptions);
			}
			return targetData;
		},
		isAddedMetricSeries: function(seriesObj) {
			return seriesObj.userAddedMetricSeries;
		},
		getThresholdValueMarkerFromOptions: function(chartOptions, isMetricSeries) {
			return isMetricSeries ? "y" : chartOptions && chartOptions.valueMarker ? chartOptions.valueMarker : null;
		},
		getThresholdSourceIndex: function(threshold) {
			let mSourceIndex = -1;
			if (threshold && threshold.sourceId) {
				mSourceIndex = this.getChartDataMapper().getColumnIndexById(threshold.sourceId);
			}
			if (mSourceIndex !== -1) {
				return mSourceIndex;
			}
			if (threshold && threshold.source) {
				mSourceIndex = this.getChartDataMapper().getColumnIndex(threshold.source, this.getChartDataMapper().titles);
			}
			return mSourceIndex;
		},
		processThreshold: function(targetData, targetName, threshold, chartDataMapper, chartOptions, sourceData) {
			if (chartDataMapper) {
				this.setChartDataMapper(chartDataMapper);
				this.getThresholdHelper().setChartDataMapper(chartDataMapper);
			}
			let isMetricSeries = this.isAddedMetricSeries(targetData),
				sourceIndex = this.getThresholdSourceIndex(threshold),
				targetIndex = (threshold.type !== this.ENUM_THRESHOLD_TYPE.ATTRIBUTE && this.pickFromSource) ? sourceIndex : this.getThresholdHelper().getTargetMetricIndex(targetName, isMetricSeries, threshold),
				mSourceData = this.getThresholdSourceData(sourceData, chartOptions, targetData ? targetData.data : null, isMetricSeries);

			if (threshold.type === this.ENUM_THRESHOLD_TYPE.ATTRIBUTE) {
				threshold.targetValues = this.getAttributeThresholdHelper().computeThreshold(threshold, sourceIndex, targetIndex, this.getThresholdValueMarkerFromOptions(chartOptions, isMetricSeries), null, true);
			} else {
				threshold.targetValues = this.getThresholdHelper().computeThreshold(threshold, sourceIndex, targetIndex, targetName, this.getThresholdValueMarkerFromOptions(chartOptions, isMetricSeries), mSourceData);
			}
			if (threshold.color || threshold.markerType || threshold.enableDataLabel || threshold.panelColor) {
				this.getThresholdMapper().setThreshold(targetData, threshold.targetValues, threshold, sourceIndex, this.getThresholdOptions(chartOptions, sourceIndex, targetIndex), sourceData);
 			}
 			return targetData;
 		},
		getThresholdSourceData: function(data, options, targetData, isMetricSeries) {
			if (isMetricSeries) {
				return targetData;
			}
			if(!data){
				return null;
			}
			if(options && options.datakey){
				return data[options.datakey];
			}	
			return data;
		},
		 getThresholdOptions: function(options, sourceIndex, targetIndex) {
			 if (!options) {
				 if (this.isTargetIndexEnabled() && targetIndex !== -1) {
					 return {
						 'targetIndex': targetIndex
					 }
				 } else {
					 return {
						 'targetIndex': sourceIndex
					 }
				 }
			 }
			 return options;
		 },
		 getSeriesThresholds: function(thresholdsCol, mSeries) {
			 if (thresholdsCol[mSeries.name]) {
				 return thresholdsCol[mSeries.name];
			 }

			 let mSeriesThresholdCol = [];

			 if (!mSeries.sId) {
				 return mSeriesThresholdCol;
			 }

			 vitaraLD.each(thresholdsCol, function (mThresholds, mTarget) {
				 vitaraLD.each(mThresholds, function(mThreshold){
					 if (mThreshold.targetId && utils.validateSeriesIds(mThreshold.targetId, mSeries.sId)) {
						 mSeriesThresholdCol.push(mThreshold);
					 }
				 });
			 });
			 return mSeriesThresholdCol;
		 },

		/**
		 * helper function to evaluate threshold collection map
		 */
 		processGenericThreshold: function(thresholds, series, chartDataMapper, chartOptions, sourceData) {
			//skip evaluating grid threhsolds here, gird threshold collection is an array.
			if (vitaraLD.isArray(thresholds)){
				return series;
			}
 			this.setChartDataMapper(chartDataMapper);
			thresholds = this.procThresholdsPreCleanUp(thresholds, series);
 			for (var i = 0; i < series.length; i++) {
 				var seriesThresholds = this.getSeriesThresholds(thresholds, series[i]);
 				if (seriesThresholds && seriesThresholds.length) {
 					for (var j = 0; j < seriesThresholds.length; j++) {
						if (seriesThresholds[j].type && seriesThresholds[j].type === this.ENUM_THRESHOLD_TYPE.PLOT_LINE){
							series[i] = this.setPlotLineThreshold(series[i], seriesThresholds[j], chartOptions);							
						}
						else {
							series[i] = this.processThreshold(series[i], series[i].name, seriesThresholds[j], null, chartOptions, +seriesThresholds[j].level === 1 ? sourceData : null);
						}
 					}
 				}
 			}
 			if (!this.getThresholdHelper().isSeriesByMetric() && thresholds['All']) {
				 var seriesThresholds = thresholds['All'], 
				 	 self = this,
				 	 mTargetSeriesPartition = vitaraLD.partition(series, function(seriesObj) {
					 	return !self.isAddedMetricSeries(seriesObj);
					 }),
					 mTargetSeriesCol = mTargetSeriesPartition[0];

 				for (var i=0; i<seriesThresholds.length; i++){
 					for (var j=0; j<mTargetSeriesCol.length; j++){
						if (seriesThresholds[i].type && seriesThresholds[i].type === this.ENUM_THRESHOLD_TYPE.PLOT_LINE){
							mTargetSeriesCol[j] = this.setPlotLineThreshold(mTargetSeriesCol[j], seriesThresholds[i], chartOptions);							
						}
						else {
							mTargetSeriesCol[j] = this.processThreshold(mTargetSeriesCol[j], mTargetSeriesCol[j].name, seriesThresholds[i], null, chartOptions, +seriesThresholds[i].level === 1 ? sourceData : null);
						}
 					}
				}
				if (mTargetSeriesPartition[1].length) {
					series = [].concat(mTargetSeriesCol, mTargetSeriesPartition[1]);
				}
 			}
 			this.destroy();
 			return series;
		 },
 		destroy: function(){
 			this.chartDataMapper = null;
 			this.thresholdHelper = null;
 		},
		getTargetTitles: function(series, thresholds) {
			var self = this;
			var targetTitles = [];
			vitaraLD.each(series, function (obj) {
				if (self?.context?.isTrellisMode?.()) {
					self.SMALL_MULTIPLES_Titles.push(obj.name);
				} else {
					targetTitles.push(obj.name);
				}
			})
			targetTitles = self.SMALL_MULTIPLES_Titles.length > 0 ? self.SMALL_MULTIPLES_Titles : targetTitles;
			if (!this.getThresholdHelper().isSeriesByMetric() && thresholds['All']) {
				targetTitles.push('All');
			}
			return targetTitles;
		},
		getSourceTitles: function(){
			return this.getChartDataMapper().titles;
			//return this.getChartDataMapper().titles.slice(this.getChartDataMapper().numAttributes, this.getChartDataMapper().titles.length);
		},
		getSourceIdentifiers: function() {
			return this.getChartDataMapper().getColumnIdentifiers();
		},
		getTargetIdentifiers: function(mSeries) {
			return vitaraLD.map(mSeries, function(seriesObj) {
				return seriesObj.sId
			});
		},
        setContextThresholds: function(thresholds){
        	if (this.context) {
        		this.context.vizProps.thresholds = thresholds;
        		this.context.updateChartSavedState(this.context.vizProps);
        	}
		},
		getPlotLines: function(){
			if (this.context && this.context.vizProps && this.context.vizProps.plotLines){
				return this.context.vizProps.plotLines;
			}
			return [];
		},
		getPlotLineIndexByLabel: function(label){
			return vitaraLD.findIndex(this.getPlotLines(), function(o){return o.label === label});
		},
		getPlotLineByLabel: function(label, plotLines){
			return (plotLines || this.getPlotLines())[this.getPlotLineIndexByLabel(label)];
		},
		isPlotLine: function(label){
			return this.getPlotLineIndexByLabel(label) !== -1;
		},
		procThresholdsPreCleanUp: function(thresholds, series){
			var otherTitles = ['Chart Background', 'Nodes', 'Links', 'Background', 'Title', 'Main Label', 'Sub Label']; //other titles were exempted too
 			var targetTitles = this.getTargetTitles(series, thresholds),
			 	thresholdTargetIds = this.getTargetIdentifiers(series), 
			 	sourceIds = this.getSourceIdentifiers(),
				sourceTitles = this.getSourceTitles(), 
				isValidThresholdTarget = function (threshold) {
					if(!thresholdTargetIds || !thresholdTargetIds.length){
						return -1 !== targetTitles.indexOf(threshold.target);
					}
					return -1 !== vitaraLD.findIndex(thresholdTargetIds, function (sId) {
						if(sId && threshold.targetId){
							return utils.validateSeriesIds(sId, threshold.targetId);
						}
						return -1 !== targetTitles.indexOf(threshold.target);
					});
				},
				isValidThresholdSource = function (threshold) {
					if(!sourceIds || !sourceIds.length){
						return -1 !== sourceTitles.indexOf(threshold.source);
					}
					return -1 !== vitaraLD.findIndex(sourceIds, function (sId) {
						if (sId && threshold.sourceId) {
							return utils.validateSeriesIds(sId, threshold.sourceId);
						}
						return -1 !== sourceTitles.indexOf(threshold.source);
					});
				};

			for (var key in thresholds){
 				if (targetTitles.indexOf(key) === -1 && otherTitles.indexOf(key) === -1) {
					 //delete thresholds[key];
					 thresholds[key]  = vitaraLD.map(thresholds[key], function(mThreshold){
						 if (mThreshold.targetId && isValidThresholdTarget(mThreshold)) {
							 return mThreshold;
						 } else {
							 mThreshold.dangle = true;
							 mThreshold.dangleMsg = "target not available";
							 return mThreshold;
						 }
					});
				} else {
					for (var i = thresholds[key].length - 1; i > -1; i--) {		
						if (!isValidThresholdSource(thresholds[key][i]) && !this.isPlotLine(thresholds[key][i].source)) {
							//thresholds[key].splice(i, 1);
							thresholds[key][i].dangle = true;
							thresholds[key][i].dangleMsg = "source not available";
						}
						else {
							thresholds[key][i].dangle = false;
							thresholds[key][i].dangleMsg = "";
						}
					}
				}
 			}
 			this.setContextThresholds(vitaraLD.cloneDeep(thresholds));

			vitaraLD.each(thresholds, function(arr, key){
				thresholds[key] = vitaraLD.filter(arr, function(o){return !o.dangle;})
			});
			return thresholds;
        },
		getFiveScaleThresholds: function(source, colors, opts) {
			var uzColor = this.context.defaultUnzonedElemColor || '#ffffbf';
			return [{
				source: source,
				sourceId: opts.sourceId,
				target: opts.target,
				targetId: opts.targetId,
				condition: 'bottompercentage',
				color: colors[0],
				defaultColor: colors[0],
				values: [20]
			}, {
				source: source,
				sourceId: opts.sourceId,
				target: opts.target,
				targetId: opts.targetId,
				condition: 'betweenpercentage',
				color: colors[1],
				defaultColor: colors[1],
				values: [20, 40]
			}, {
				source: source,
				sourceId: opts.sourceId,
				target: opts.target,
				targetId: opts.targetId,
				condition: 'betweenpercentage',
				color: colors[2],
				defaultColor: colors[2],
				values: [40, 60]
			}, {
				source: source,
				sourceId: opts.sourceId,
				target: opts.target,
				targetId: opts.targetId,
				condition: 'betweenpercentage',
				color: colors[3],
				defaultColor: colors[3],
				values: [60, 80]
			}, {
				source: source,
				sourceId: opts.sourceId,
				target: opts.target,
				targetId: opts.targetId,
				condition: 'toppercentage',
				color: colors[4],
				defaultColor: colors[4],
				values: [20]
			}]
		},
		getFiveScaleGrThresholds: function(source, colors, gid, opts){
			gid = gid || 'default_gid';
			var grColors = this.getGrColorScales(colors[0], colors[colors.length-1], 5);
			var thresholds = this.getFiveScaleThresholds(source, grColors, opts);	
			if (thresholds && thresholds.length) {
				for (var i = 0; i < thresholds.length; i++) {
					thresholds[i].gid = gid;
					thresholds[i].id = gid+"-"+i;
				}
			}
			return thresholds;
		},
		getThresholdsFromColorStops: function(vizProps, source){
			var result = [];
			for (var i=0; i<7; i++) {
				if (vizProps["colorStopStart" + i] && vizProps["colorStopEnd" + i] && vizProps["colorStopFillColor" + i]) {
					result.push({
						condition: 'between',
						source: source,
						color: vizProps["colorStopFillColor" + i],
						values: [vizProps["colorStopStart" + i], vizProps["colorStopEnd" + i]]
					});
					delete vizProps["colorStopStart" + i];
					delete vizProps["colorStopEnd" + i];
					delete vizProps["colorStopFillColor" + i];
				}
			}
			return result;
		},
		processRangeThresholds: function (thresholds, series, chartDataMapper, chartOptions, rangePoints) {
			this.setChartDataMapper(chartDataMapper);
			//thresholds = this.procThresholdsPreCleanUp(thresholds, series);
			for (var i = 0; i < series.length; i++) {
				var seriesThresholds = thresholds[series[i].name];
				if (seriesThresholds && seriesThresholds.length) {
					for (var j = 0; j < seriesThresholds.length; j++) {
						series[i] = this.getThresholdRanges(series[i], series[i].name, seriesThresholds[j], null, chartOptions, rangePoints);
					}
				}
			}
			this.destroy();
			return series;
		},
		processThresholdsForValue: function(thresholds, series, values, dataHelper){
			this.setChartDataMapper(dataHelper);
			for (var i = 0; i < series.length; i++) {
				var seriesThresholds = thresholds[series[i].name];
				if (seriesThresholds && seriesThresholds.length) {
					for (var j = 0; j < seriesThresholds.length; j++) {
						seriesThresholds[j].targetValues = this.getThresholdHelper().computeThresholdValue(seriesThresholds[j], values[seriesThresholds[j].source]);
						if (seriesThresholds[j].color || seriesThresholds[j].markerType || seriesThresholds[j].enableDataLabel) {
							this.getThresholdMapper().setThreshold(series[i], seriesThresholds[j].targetValues, seriesThresholds[j]);
						}
					}
				}
			}
			this.destroy();
			return series;
		},
		getThresholdRanges: function (targetData, targetName, threshold, chartDataMapper, chartOptions, rangePoints) {
			var sourceIndex = this.chartDataMapper.getColumnIndex(this.context.renderedChartInstance.getGaugeMetric(threshold.source), this.chartDataMapper.originalTitles);
			threshold.targetValues = this.getThresholdHelper().computeThresholdRange(threshold, sourceIndex, targetName, rangePoints);
			if (threshold.color || threshold.markerType || threshold.enableDataLabel) {
				this.getThresholdMapper().setThreshold(targetData, threshold.targetValues, threshold, rangePoints);
			}
			return targetData;
		},
		formGradietThresholdOptions: function(options){
			var result = [], cnt = Number(options.count);
			if (options.csr.colorScales.length === cnt && options.csr.colorRanges.length === cnt+1) {
				for (var i=0; i<cnt; i++){
					if (i===0) {
						result.push(
							{
								source: options.source,
								sourceId: options.sourceId,
								target: options.target,
								targetId: options.targetId,
								condition: 'bottompercentage',
								color: options.csr.colorScales[i],
								gid: options.gid,
								id: options.gid + "-" + i,
								values: [options.csr.colorRanges[i+1] - options.csr.colorRanges[i]],
								alias: options.alias,
								invert: options.invert,
								customGradientStops: options.customGradientStops
							}
						);
					}
					else if (i===cnt-1) {
						result.push(
							{
								source: options.source,
								sourceId: options.sourceId,
								target: options.target,
								targetId: options.targetId,
								condition: 'toppercentage',
								color: options.csr.colorScales[i],
								gid: options.gid,
								id: options.gid + "-" + i,
								values: [options.csr.colorRanges[i+1] - options.csr.colorRanges[i]],
								alias: options.alias,
								invert: options.invert,
								customGradientStops: options.customGradientStops
							}
						);
					}
					else {
						result.push(
							{
								source: options.source,
								sourceId: options.sourceId,
								target: options.target,
								targetId: options.targetId,
								condition: 'betweenpercentage',
								color: options.csr.colorScales[i],
								gid: options.gid,
								id: options.gid + "-" + i,
								values: [options.csr.colorRanges[i], options.csr.colorRanges[i+1]],
								alias: options.alias,
								invert: options.invert,
								customGradientStops: options.customGradientStops
							}
						);
					}
				}
			}
			return result;
		},
		getGrColorScales: function(startClr, endClr, cnt){
			if (!startClr && !endClr && !cnt && !d3Interpolate) {
				return null;
			}
			return d3Interpolate.quantize(d3Interpolate.interpolateLab(startClr, endClr), cnt);
		},
		getCreateGradientThresholds: function(options){
			var result = [], cnt = Number(options.count);
			if (!options.csr && options.startColor && options.endColor && cnt) {
				options.csr = this.context.utils.getColorScalesAndRanges(options.startColor, options.endColor, cnt);
			}
			result = this.formGradietThresholdOptions(options);
			return result;
		},
		//to-do: refactor, reuse to be maintained.
		getRandomBtwn: function(min, max){
            return Math.floor(Math.random() * (max - min)) + min;
        },
        getNewId: function(){
            //collision check is a must, return val is not a uid
            return this.getRandomBtwn(100000, 999999);
		},
		getNewUID: function (thresholds) {
			var uid = this.getNewId();
			while (vitaraLD.find(thresholds, function (k) {
					return (vitaraLD.findIndex(thresholds[k], function (o) {
						return o.gid === uid || o.id === uid;
					}) !== -1);
				})) {
				this.getNewUID();
			}
			return uid;
		},
		isTargetIndexEnabled: function() {
			return this.getThresholdHelper().getTargetIndexUsage();
		},
		setTargetIndexUsage: function(value) {
			this.getThresholdHelper().setTargetIndexUsage(value);
		},
		isEmpty: function(threhsoldCol){
			return vitaraLD.isEmpty(threhsoldCol);
		},
		isTypeOf: function(threhsoldsCol) {
			if (vitaraLD.isArray(threhsoldsCol)) {
				return this.ENUM_THRESHOLD_COL_TYPE.GRID_COL;
			} else if (vitaraLD.isPlainObject(threhsoldsCol)) {
				return this.ENUM_THRESHOLD_COL_TYPE.CHART_COL;
			} else {
				return this.ENUM_THRESHOLD_COL_TYPE.INVALD;
			}
		}
	};

	export {ThresholdHelper}
 
	 
